#if !defined(AFX_FILEDETAILS_H__4805DC73_A051_46B8_8E38_2C45C876E923__INCLUDED_)
#define AFX_FILEDETAILS_H__4805DC73_A051_46B8_8E38_2C45C876E923__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FileDetails.h : header file
//

#include "..\resource.h"
#include "..\PartFile.h"
#include "..\MuleListCtrl.h"
#include "ScrollStatic.h"
#include "PartsChecker.h"	// CFDParts
#include "Separator.h"		// CFDAviInfo
#include "afxwin.h"

/////////////////////////////////////////////////////////////////////////////
// CFDGeneral dialog

class CFDGeneral : public CPropertyPage
{
	DECLARE_DYNCREATE(CFDGeneral)

// Construction
public:
	CFDGeneral();
	~CFDGeneral();

	void UpdateData();

	CPartFile* m_pFile;

// Dialog Data
	//{{AFX_DATA(CFDGeneral)
	enum { IDD = IDD_FDPPG_GENERAL };
	CScrollStatic	m_ctrlPartfileStatus;
	CScrollStatic	m_ctrlMetFile;
	CScrollStatic	m_ctrlHash;
	CScrollStatic	m_ctrlFolder;
	CScrollStatic	m_ctrlFiletype;
	CScrollStatic	m_ctrlFilesize;
	CScrollStatic	m_ctrlDescription;
	CScrollStatic	m_ctrlCategorie;
	CStatic			m_ctrlFileIcon;
	CEdit			m_ctrlFilename;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFDGeneral)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hFileIcon;

	// Generated message map functions
	//{{AFX_MSG(CFDGeneral)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedCommentsBtn();
	virtual BOOL OnInitDialog();
};

/////////////////////////////////////////////////////////////////////////////
// CFDParts dialog

class CFDParts : public CPropertyPage
{
	DECLARE_DYNCREATE(CFDParts)

// Construction
public:
	CFDParts();
	~CFDParts();

	void UpdateData();

	CPartFile* m_pFile;

// Dialog Data
	//{{AFX_DATA(CFDParts)
	enum { IDD = IDD_FDPPG_PARTS };
	CPartsChecker	m_ctrlParts;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFDParts)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
		
	// Generated message map functions
	//{{AFX_MSG(CFDParts)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CFDTransfer dialog

class CFDTransfer : public CPropertyPage
{
	DECLARE_DYNCREATE(CFDTransfer)

// Construction
public:
	CFDTransfer();
	~CFDTransfer();

	void UpdateData();

	CPartFile* m_pFile;

// Dialog Data
	//{{AFX_DATA(CFDTransfer)
	enum { IDD = IDD_FDPPG_TRANSFER };
	CScrollStatic	m_ctrlTransferingSources;
	CScrollStatic	m_ctrlTransfered;
	CScrollStatic	m_ctrlPartCnt;
	CScrollStatic	m_ctrlLastSeenComplete;
	CScrollStatic	m_ctrlICHrecovered;
	CScrollStatic	m_ctrlFoundSources;
	CScrollStatic	m_ctrlDatarate;
	CScrollStatic	m_ctrlCompletedSize;
	CScrollStatic	m_ctrlAvailableParts;
	CScrollStatic	m_ctrlLastReception;
	CScrollStatic	m_ctrlCompPerc;
	CScrollStatic	m_ctrlCorruptionLoss;
	CScrollStatic	m_ctrlCompressionGain;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFDTransfer)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CFDTransfer)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
};

/////////////////////////////////////////////////////////////////////////////
// CFDAviInfo dialog

class CFDAviInfo : public CPropertyPage
{
	DECLARE_DYNCREATE(CFDAviInfo)

// Construction
public:
	CFDAviInfo();
	~CFDAviInfo();

// Dialog Data
	//{{AFX_DATA(CFDAviInfo)
	enum { IDD = IDD_FDPPG_AVIINFO };
	CScrollStatic	m_ctrlWidth;
	CScrollStatic	m_ctrlVideoCodec;
	CScrollStatic	m_ctrlVideoBitrate;
	CScrollStatic	m_ctrlSamplerate;
	CScrollStatic	m_ctrlHeight;
	CScrollStatic	m_ctrlFPS;
	CScrollStatic	m_ctrlChannel;
	CScrollStatic	m_ctrlAudioCodec;
	CScrollStatic	m_ctrlAudioBitrate;
	CScrollStatic	m_ctrlFilesize;
	CScrollStatic	m_ctrlFilelength;
	CSeparator		m_ctrlVideoLbl;
	CSeparator		m_ctrlPictureLbl;
	CSeparator		m_ctrlAudioLbl;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFDAviInfo)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CFDAviInfo)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void UpdateData();
	void Localize();

	CPartFile* m_pFile;
	long m_lAbitrate;
	BOOL m_bARoundBitrate;
	
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedRoundbitrateBtn();
};

/////////////////////////////////////////////////////////////////////////////
// CFDSrcNames dialog

class CFDSrcNames : public CPropertyPage
{
	DECLARE_DYNCREATE(CFDSrcNames)

// Construction
public:
	CFDSrcNames();
	~CFDSrcNames();

	void UpdateData();

	CPartFile* m_pFile;

// Dialog Data
	//{{AFX_DATA(CFDSrcNames)
	enum { IDD = IDD_FDPPG_SOURCENAMES };
		// NOTE - ClassWizard will add data members here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFDSrcNames)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CFDSrcNames)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	static int CALLBACK CompareListNameItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);	// Juanjo

private:
	void FillSourcenameList();
	

	CMuleListCtrl* m_lstSources;
	bool m_bSortAscending[2];
public:
	afx_msg void OnLvnColumnclick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult);
	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam );

	CButton m_ctrlTakeOver;
	CButton m_ctrlCleanUp;
	CButton m_ctrlRename;
	afx_msg void OnBnClickedRename();
	afx_msg void OnBnClickedCleanup();
	afx_msg void OnBnClickedFdsTakeover();
	CEdit m_ctrlFilename;
	virtual BOOL OnInitDialog();
};

/////////////////////////////////////////////////////////////////////////////
// CFileDetails

class CFileDetails : public CPropertySheet
{
	DECLARE_DYNAMIC(CFileDetails)

// Construction
public:
	CFileDetails(UINT nIDCaption, CPartFile* pFile, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CFileDetails(LPCTSTR pszCaption, CPartFile* pFile, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	virtual BOOL OnInitDialog();

	void Init(CPartFile* pFile);
	void UpdateData();
	void Localize();

protected:
	CFDGeneral	m_wndGeneral;
	CFDTransfer	m_wndTransfer;
	CFDSrcNames	m_wndSourceNames;
	CFDParts	m_wndParts;
	CFDAviInfo	m_wndAviInfo;

	CPartFile*	m_pFile;
	UINT		m_nTimer;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileDetails)
	public:
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFileDetails();

	// Generated message map functions
protected:
	//{{AFX_MSG(CFileDetails)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.


#endif // !defined(AFX_FILEDETAILS_H__4805DC73_A051_46B8_8E38_2C45C876E923__INCLUDED_)
