// EngineData.h
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "Loggable.h"
#include "Sockets/Tasks.h"

#ifdef NEW_SOCKETS

typedef enum
{
	SERVER_DISCONNECTED,
	SERVER_FULL,
	SERVER_CONNECTING,
	SERVER_WAITFORLOGIN,
	SERVER_CONNECTED
} ServerStates;

class CServer;
class CServerList;
class CPreferences;

class CEngineData : public CLoggable
{
public:
	CEngineData(CEmEngine& stEngine);
	~CEngineData();

	// Server Info
	bool IsConnecting();
	bool IsConnected();
	bool IsLowID();

	void ImportServerState(CTask_ServerState* pTask);

	// Update Server Info
	void SetConnectionState(short nConnectionState);
	void SetClientID(long cID);
	void ConnectingTo(CEmClient_Server* pClient);
	void ConnectedTo(CEmClient_Server* pClient);

	SOCKET GetConnectedServer(){ return m_hServer; }
	SOCKET GetConnectingServer(){ return m_hNewServer; }

	// Global preferences
	BYTE* GetUserHash();
	LONG GetPort();
	CString GetUserNick();

private:
	void ExportServerState();

private:
	short	m_nConnectionState;
	long	m_nClientID;

	CEmEngine&	m_stEngine;

	CServer*		m_pCurrentServer;
	CServer*		m_pNewServer;
	CServerList*	m_pServerList;
	SOCKET			m_hServer;
	SOCKET			m_hNewServer;
};

#endif //NEW_SOCKETS