#pragma once

#include "preferences.h"
#include "afxwin.h"

// CPPgTweaks dialog

class CPPgBackup : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgBackup)

public:
	CPPgBackup();
	virtual ~CPPgBackup();

	void SetPrefs(CPreferences* in_prefs) {	app_prefs = in_prefs;}

	// Dialog Data
	enum { IDD = IDD_PPG_BACKUP };
protected:
	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}
	CPreferences *app_prefs;
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
public:
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	void Localize(void);

private:
	void LoadSettings();
	void CheckBackupNowButton();
	bool guardian;
	bool SelectDir(TCHAR* outdir, CString titletext);
public:
	DECLARE_MESSAGE_MAP()
	afx_msg void OnBnClickedBackupnow();
	afx_msg void OnBnClickedDat();
	afx_msg void OnBnClickedMet();
	afx_msg void OnBnClickedIni();
	afx_msg void OnBnClickedPart();
	afx_msg void OnBnClickedPartMet();
	afx_msg void OnBnClickedSelectall();
	afx_msg void OnBnClickedAutobackup();
	afx_msg void OnBnClickedOverwrite();
	afx_msg void OnBnClickedBrowse();
	afx_msg void OnEnChangeBackupDir();
	afx_msg void OnBnClickedBackupAuto();
protected:
	BOOL datFiles;
	BOOL metFiles;
	BOOL iniFiles;
	BOOL partFiles;
	BOOL partMetFiles;
	BOOL autoBackup;
	BOOL overwriteFiles;
	CString backupDir;
private:
	CString backupTypeDesc;
	CButton selectAllButton;
	CButton backupNowButton;
	CString backupOptionDesc;
	CString backupDirDesc;
	CButton autoBackupCheck;
	CButton overwriteFilesCheck;
	CEdit backupDirEdit;
	CButton backupBrowseButton;
};
