// PPgSorting.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgSorting.h"
#include "ArrowCombo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// PPgSorting dialog

IMPLEMENT_DYNAMIC(CPPgSorting, CPropertyPage)
CPPgSorting::CPPgSorting()
	: CPropertyPage(CPPgSorting::IDD)
	, updateQueue(FALSE)
	, useIt(FALSE)
	, sources2Sort(FALSE)
	, sortServersDesc(_T(""))
	, sortDownloadsDesc(_T(""))
	, sortUploadsDesc(_T(""))
	, sortQueueDesc(_T(""))
	, sortSearchDesc(_T(""))
	, sortIrcDesc(_T(""))
	, sortFilesDesc(_T(""))
	, sortSources1Desc(_T(""))
	, sortGrpDesc(_T(""))
{
}

CPPgSorting::~CPPgSorting()
{
}

void CPPgSorting::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SORT_SERVERS, serverColsCombo);
	DDX_Control(pDX, IDC_SORT_FILES, fileColsCombo);
	DDX_Control(pDX, IDC_SORT_DOWNLOADS, downloadColsCombo);
	DDX_Control(pDX, IDC_SORT_UPLOADS, uploadColsCombo);
	DDX_Control(pDX, IDC_SORT_QUEUE, queueColsCombo);
	DDX_Control(pDX, IDC_SORT_SEARCH, searchColsCombo);
	DDX_Control(pDX, IDC_SORT_IRC, ircColsCombo);
	DDX_Control(pDX, IDC_SORT_SOURCES1, sourceCols1Combo);
	DDX_Control(pDX, IDC_SORT_SOURCES2, sourceCols2Combo);
	DDX_Check(pDX, IDC_UPDATEQUEUE, updateQueue);
	DDX_Check(pDX, IDC_SORT_USEIT, useIt);
	DDX_Check(pDX, IDC_SORT_SOURCES2_BOX, sources2Sort);
	DDX_Text(pDX, IDC_SORT_SERVERS_LBL, sortServersDesc);
	DDX_Text(pDX, IDC_SORT_DOWNLOADS_LBL, sortDownloadsDesc);
	DDX_Text(pDX, IDC_SORT_UPLOADS_LBL, sortUploadsDesc);
	DDX_Text(pDX, IDC_SORT_QUEUE_LBL, sortQueueDesc);
	DDX_Text(pDX, IDC_SORT_SEARCH_LBL, sortSearchDesc);
	DDX_Text(pDX, IDC_SORT_IRC_LBL, sortIrcDesc);
	DDX_Text(pDX, IDC_SORT_FILES_LBL, sortFilesDesc);
	DDX_Text(pDX, IDC_SORT_SOURCES1_LBL, sortSources1Desc);
	DDX_Text(pDX, IDC_SORT_GRP, sortGrpDesc);
	DDX_Control(pDX, IDC_UPDATEQUEUE, updateQueueCheck);
	DDX_Control(pDX, IDC_SORT_SOURCES2_BOX, sortSources2Check);
	DDX_Control(pDX, IDC_SORT_USEIT, useItCheck);
}

BEGIN_MESSAGE_MAP(CPPgSorting, CPropertyPage)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SORT_USEIT, OnBnClickedUseSort)
	ON_CBN_SELCHANGE(IDC_SORT_SERVERS, OnCbnSelchangeSortServers)
	ON_CBN_SELCHANGE(IDC_SORT_FILES, OnCbnSelchangeSortFiles)
	ON_CBN_SELCHANGE(IDC_SORT_DOWNLOADS, OnCbnSelchangeSortDownloads)
	ON_CBN_SELCHANGE(IDC_SORT_SOURCES1, OnCbnSelchangeSortSources1)
	ON_CBN_SELCHANGE(IDC_SORT_SOURCES2, OnCbnSelchangeSortSources2)
	ON_CBN_SELCHANGE(IDC_SORT_UPLOADS, OnCbnSelchangeSortUploads)
	ON_CBN_SELCHANGE(IDC_SORT_QUEUE, OnCbnSelchangeSortQueue)
	ON_CBN_SELCHANGE(IDC_SORT_SEARCH, OnCbnSelchangeSortSearch)
	ON_CBN_SELCHANGE(IDC_SORT_IRC, OnCbnSelchangeSortIrc)
	ON_BN_CLICKED(IDC_SORT_SOURCES2_BOX, OnBnClickedSortSources2Box)
	ON_BN_CLICKED(IDC_UPDATEQUEUE, OnBnClickedUpdateQueueList)
END_MESSAGE_MAP()

BOOL CPPgSorting::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	LoadSettings();
	Localize();
	return TRUE;
}

void CPPgSorting::LoadSettings(void)
{
	useIt = app_prefs->DoUseSort();
	sources2Sort = app_prefs->DoUseSrcSortCol2();
	updateQueue = app_prefs->GetUpdateQueueList();

	serverColsCombo.ResetContent();
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SL_SERVERNAME)+_T("[^]")),0);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SL_SERVERNAME)),100);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_IP)+_T("[^]")),1);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_IP)),101);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_DESCRIPTION)+_T("[^]")),2);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_DESCRIPTION)),102);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PING)+_T("[^]")),3);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PING)),103);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UUSERS)+_T("[^]")),4);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UUSERS)),104);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UUSERS)+_T("[^^]")),54);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UUSERS)+_T("[vv]")),154);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PW_FILES)+_T("[^]")),5);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PW_FILES)),105);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PRIORITY)+_T("[^]")),6);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PRIORITY)),106);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UFAILED)+_T("[^]")),7);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UFAILED)),107);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_STATICSERVER)+_T("[^]")),8);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_STATICSERVER)),108);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_SOFTLIMIT)+_T("[^]")),9);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_SOFTLIMIT)),109);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_HARDLIMIT)+_T("[^^]")),59);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_HARDLIMIT)+_T("[vv]")),159);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_VERSION)+_T("[^]")),10);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_VERSION)),110);

	fileColsCombo.ResetContent();
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_FILENAME)+_T("[^]")),0);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_FILENAME)),100);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_SIZE)+_T("[^]")),1);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_SIZE)),101);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_TYPE)+_T("[^]")),2);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_TYPE)),102);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PRIORITY)+_T("[^]")),3);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PRIORITY)),103);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PERMISSION)+_T("[^]")),4);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PERMISSION)),104);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_FILEID)+_T("[^]")),5);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_FILEID)),105);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)+_T("[^]")),6);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)),106);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)+_T("[^^]")),10006);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)+_T("[vv]")),10106);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)+_T("[^]")),7);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)),107);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)+_T("[^^]")),10007);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)+_T("[vv]")),10107);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)+_T("[^]")),8);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)),108);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)+_T("[^^]")),10008);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)+_T("[vv]")),10108);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)+_T("[^]")),9);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)),109);	//Cax2 bugfix 05/01/03
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)+_T("[^^]")),10009);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)+_T("[vv]")),10109);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)+_T("[^]")),10);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)),110);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)+_T("[^^]")),10010);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)+_T("[vv]")),10110);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)+_T("[^]")),11);	//netwolf (zegzav)
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)),111);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)+_T("[^^]")),10011);	//netwolf (zegzav)
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)+_T("[vv]")),10111);
		
	uploadColsCombo.ResetContent();
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_QL_USERNAME)),10);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_FILE)+_T("[^]")),1);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_FILE)),11);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),2);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_SPEED)),12);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),3);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_TRANSF)),13);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_WAITED)+_T("[^]")),4);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_WAITED)),14);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UPLOADTIME)+_T("[^]")),5);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UPLOADTIME)),15);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_STATUS)+_T("[^]")),6);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_STATUS)),16);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UP_PARTS)+_T("[^]")),7);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UP_PARTS)),17);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),8);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)),18);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_COMPRESSION)+_T("[^]")),9);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_COMPRESSION)),19);

	queueColsCombo.ResetContent();
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_USERNAME)),100);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILE)+_T("[^]")),1);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILE)),101);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILEPRIO)+_T("[^]")),2);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILEPRIO)),102);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_UP_PARTS)+_T("[^]")),3);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_UP_PARTS)),103);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),4);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_DL_PROGRESS)),104);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_RATING)+_T("[^]")),5);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_RATING)),105);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SCORE)+_T("[^]")),6);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SCORE)),106);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SFRATIO)+_T("[^]")),7);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SFRATIO)),107);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_RFRATIO)+_T("[^]")),8);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_RFRATIO)),108);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ASKED)+_T("[^]")),9);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ASKED)),109);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_LASTSEEN)+_T("[^]")),10);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_LASTSEEN)),110);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ENTERQUEUE)+_T("[^]")),11);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ENTERQUEUE)),111);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_BANNED)+_T("[^]")),12);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_BANNED)),112);

	searchColsCombo.ResetContent();
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_FILENAME)+_T("[^]")),0);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_FILENAME)),10);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SIZE)+_T("[^]")),1);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SIZE)),11);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SOURCES)+_T("[^]")),2);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SOURCES)),12);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_TYPE)+_T("[^]")),3);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_TYPE)),13);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_FILEID)+_T("[^]")),4);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_FILEID)),14);

	ircColsCombo.ResetContent();
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_IRC_NAME)+_T("[^]")),0);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_IRC_NAME)),10);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_UUSERS)+_T("[^]")),1);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_UUSERS)),11);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_DESCRIPTION)+_T("[^]")),2);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_DESCRIPTION)),12);

	downloadColsCombo.ResetContent();
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_FILENAME)+_T("[^]")),0);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_FILENAME)),100);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SIZE)+_T("[^]")),1);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SIZE)),101);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),2);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_TRANSF)),102);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_SF_COMPLETED)+_T("[^]")),3);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_SF_COMPLETED)),103);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),4);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SPEED)),104);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),5);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)),105);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SOURCES)+_T("[^]")),6);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SOURCES)),106);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_PRIORITY)+_T("[^]")),7);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_PRIORITY)),107);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_STATUS)+_T("[^]")),8);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_STATUS)),108);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_REMAINS)+_T("[^]")),9);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_REMAINS)),109);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_TIME)+_T("[^]")),10);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_TIME)),110);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_INFLST_FILE_LASTSEENCOMPLETE)+_T("[^]")),13); //katsyonak 01.06.03
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_INFLST_FILE_LASTSEENCOMPLETE)),113); //Cax2 - more than 10 columns //katsyonak 01.06.03
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_FD_LASTCHANGE)+_T("[^]")),14);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_FD_LASTCHANGE)),114);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_CAT)+_T("[^]")),15);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_CAT)),115);
		
	sourceCols1Combo.ResetContent();
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_USERNAME)),100);		//Cax2 - more than 10 columns
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),2);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_TRANSF)),102);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_SF_COMPLETED)+_T("[^]")),3);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_SF_COMPLETED)),103);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),4);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_SPEED)),104);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),5);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_PROGRESS)),105);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)+_T("[^]")),6);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)),106);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(_T("QR[^]")),7);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(_T("QR")),107);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_STATUS)+_T("[^]")),8);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_STATUS)),108);	
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_ULDL)+_T("[^]")),11);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_ULDL)),111);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_RATING)+_T("[^]")),12);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_RATING)),112);

	sourceCols2Combo.ResetContent();
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_SORT_DEFAULT)),255);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_USERNAME)),100);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),2);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_TRANSF)),102);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_SF_COMPLETED)+_T("[^]")),3);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_SF_COMPLETED)),103);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),4);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_SPEED)),104);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),5);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_PROGRESS)),105);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)+_T("[^]")),6);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)),106);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(_T("QR[^]")),7);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(_T("QR")),107);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_STATUS)+_T("[^]")),8);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_STATUS)),108);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_ULDL)+_T("[^]")),11);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_ULDL)),111);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_RATING)+_T("[^]")),12);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_RATING)),112);


	sourceCols2Combo.EnableWindow(sources2Sort);
	
	int i;
	int gc;
	
	serverColsCombo.SetCurSel(0);
	gc = serverColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(serverColsCombo.GetItemData(i) == app_prefs->GetServerSortCol()) {
			serverColsCombo.SetCurSel(i);
			break;
		}

	fileColsCombo.SetCurSel(0);
	gc = fileColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(fileColsCombo.GetItemData(i) == app_prefs->GetFileSortCol()) {
			fileColsCombo.SetCurSel(i);
			break;
		}

	downloadColsCombo.SetCurSel(0);
	gc = downloadColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(downloadColsCombo.GetItemData(i) == app_prefs->GetDownloadSortCol()) {
			downloadColsCombo.SetCurSel(i);
			break;
		}

	uploadColsCombo.SetCurSel(0);
	gc = uploadColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(uploadColsCombo.GetItemData(i) == app_prefs->GetUploadSortCol()) {
			uploadColsCombo.SetCurSel(i);
			break;
		}

	queueColsCombo.SetCurSel(0);
	gc = queueColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(queueColsCombo.GetItemData(i) == app_prefs->GetQueueSortCol()) {
			queueColsCombo.SetCurSel(i);
			break;
		}

	searchColsCombo.SetCurSel(0);
	gc = searchColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(searchColsCombo.GetItemData(i) == app_prefs->GetSearchSortCol()) {
			searchColsCombo.SetCurSel(i);
			break;
		}

	ircColsCombo.SetCurSel(0);
	gc = ircColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(ircColsCombo.GetItemData(i) == app_prefs->GetIrcSortCol()) {
			ircColsCombo.SetCurSel(i);
			break;
		}

	sourceCols1Combo.SetCurSel(0);
	gc = sourceCols1Combo.GetCount();
	for(i = 0; i != gc; i++)
		if(sourceCols1Combo.GetItemData(i) == app_prefs->GetSrcSortCol1()) {
			sourceCols1Combo.SetCurSel(i);
			break;
		}

	sourceCols2Combo.SetCurSel(0);
	gc = sourceCols2Combo.GetCount();
	for(i = 0; i != gc; i++)
		if(sourceCols2Combo.GetItemData(i) == app_prefs->GetSrcSortCol2()) {
			sourceCols2Combo.SetCurSel(i);
			break;
		}

	UpdateData(FALSE);
	
	OnBnClickedUseSort();

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgSorting::OnApply()
{	
	if(m_bModified)
	{
		UpdateData(TRUE);

		app_prefs->SetUseSort(useIt);
		app_prefs->SetUseSrcSortCol2(sources2Sort);
		app_prefs->SetServerSortCol((int8)serverColsCombo.GetItemData(serverColsCombo.GetCurSel()));
		app_prefs->SetUploadSortCol((int8)uploadColsCombo.GetItemData(uploadColsCombo.GetCurSel()));
		app_prefs->SetQueueSortCol((int8)queueColsCombo.GetItemData(queueColsCombo.GetCurSel()));
		app_prefs->SetSearchSortCol((int8)searchColsCombo.GetItemData(searchColsCombo.GetCurSel()));
		app_prefs->SetIrcSortCol((int8)ircColsCombo.GetItemData(ircColsCombo.GetCurSel()));
		app_prefs->SetFileSortCol((uint16)fileColsCombo.GetItemData(fileColsCombo.GetCurSel()));
		app_prefs->SetDownloadSortCol((int8)downloadColsCombo.GetItemData(downloadColsCombo.GetCurSel()));
		app_prefs->SetSrcSortCol1((int8)sourceCols1Combo.GetItemData(sourceCols1Combo.GetCurSel()));
		app_prefs->SetSrcSortCol2((int8)sourceCols2Combo.GetItemData(sourceCols2Combo.GetCurSel()));

		app_prefs->SetUpdateQueueList(updateQueue);

		SetModified();

		if(app_prefs->DoUseSort())
		{
			theApp.emuledlg->serverwnd.serverlistctrl.SortInit(app_prefs->GetServerSortCol());
			theApp.emuledlg->transferwnd.m_wndUploadList.SortInit(app_prefs->GetUploadSortCol());
			theApp.emuledlg->transferwnd.m_wndQueueList.SortInit(app_prefs->GetQueueSortCol());
			theApp.emuledlg->searchwnd.searchlistctrl.SortInit(app_prefs->GetSearchSortCol());
			theApp.emuledlg->ircwnd.SortInit(app_prefs->GetIrcSortCol());
			theApp.emuledlg->sharedfileswnd.sharedfilesctrl.SortInit(app_prefs->GetFileSortCol());
			SetModified(FALSE);//needs the settings for downloadlistcontrol
			theApp.emuledlg->transferwnd.m_wndDownloadList.SortInit(99);//major override...
			theApp.emuledlg->transferwnd.m_wndDownloadList.SortInit(true);//normal override, in case we show sources...
		}
	}

	return CPropertyPage::OnApply();
}

void CPPgSorting::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SORTING));
		useItCheck.SetWindowText(GetResString(IDS_SORT_USEIT));
		sortServersDesc = GetResString(IDS_SORT_SERVERS_LBL);
		sortDownloadsDesc = GetResString(IDS_SORT_DOWNLOADS_LBL);
		sortUploadsDesc = GetResString(IDS_SORT_UPLOADS_LBL);
		sortQueueDesc = GetResString(IDS_SORT_QUEUE_LBL);
		sortSearchDesc = GetResString(IDS_SORT_SEARCH_LBL);
		sortFilesDesc = GetResString(IDS_SORT_FILES_LBL);
		sortIrcDesc = GetResString(IDS_SORT_IRC_LBL);
		
		sortGrpDesc = GetResString(IDS_SORT_GRP);
		sortSources1Desc = GetResString(IDS_SORT_SOURCES1_LBL);
		sortSources2Check.SetWindowText(GetResString(IDS_SORT_SOURCES2_LBL));		
		updateQueueCheck.SetWindowText(GetResString(IDS_UPDATEQUEUE));

		UpdateData(FALSE);		
	}	
}

void CPPgSorting::OnBnClickedSortSources2Box()
{
	UpdateData(TRUE);

	sourceCols2Combo.EnableWindow(sources2Sort);

	SetModified();
}

void CPPgSorting::OnBnClickedUseSort()
{
	UpdateData(TRUE);
	
	serverColsCombo.EnableWindow(useIt);
	fileColsCombo.EnableWindow(useIt);
	downloadColsCombo.EnableWindow(useIt);
	uploadColsCombo.EnableWindow(useIt);
	queueColsCombo.EnableWindow(useIt);
	searchColsCombo.EnableWindow(useIt);
	ircColsCombo.EnableWindow(useIt);
	sourceCols1Combo.EnableWindow(useIt);
	sourceCols2Combo.EnableWindow(useIt);
	if(useIt)
		sourceCols2Combo.EnableWindow(sources2Sort);
	else
		sourceCols2Combo.EnableWindow(useIt);

	SetModified();
}
