// PPgStats.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgStats.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgStats dialog

IMPLEMENT_DYNAMIC(CPPgStats, CPropertyPage)
CPPgStats::CPPgStats()
	: CPropertyPage(CPPgStats::IDD)
	, acStat(_T(""))
	, graphsUpdateInterval(0)
	, averageGraphTime(0)
	, statisticsUpdateInterval(0)
	, graphUpdateIntervalDesc(_T(""))
	, statisticsUpdateIntervalDesc(_T(""))
	, avgGraphDesc(_T(""))
	, streeDesc(_T(""))
	, acStatDesc(_T(""))
	, acRatioDesc(_T(""))
	, prefColorsDesc(_T(""))
	, graphsDesc(_T(""))
{
}

CPPgStats::~CPPgStats()
{
}

void CPPgStats::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPgStats)
	DDX_Control(pDX, IDC_COLOR_BUTTON, colorButton);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COLORSELECTOR, colorsCombo);
	DDX_Control(pDX, IDC_RATIO, ratioCombo);
	DDX_Text(pDX, IDC_ACSTAT, acStat);
	DDX_Control(pDX, IDC_SLIDER, updateIntervalSlider);
	DDX_Control(pDX, IDC_SLIDER3, averageGraphTimeSlider);
	DDX_Control(pDX, IDC_SLIDER2, statisticsUpdateIntervalSlider);
	DDX_Slider(pDX, IDC_SLIDER, graphsUpdateInterval);
	DDX_Slider(pDX, IDC_SLIDER3, averageGraphTime);
	DDX_Slider(pDX, IDC_SLIDER2, statisticsUpdateInterval);
	DDX_Text(pDX, IDC_SLIDERINFO, graphUpdateIntervalDesc);
	DDX_Text(pDX, IDC_SLIDERINFO2, statisticsUpdateIntervalDesc);
	DDX_Text(pDX, IDC_SLIDERINFO3, avgGraphDesc);
	DDX_Text(pDX, IDC_STREE, streeDesc);
	DDX_Text(pDX, IDC_ACSTAT_LBL, acStatDesc);
	DDX_Text(pDX, IDC_ACRATIO_LBL, acRatioDesc);
	DDX_Text(pDX, IDC_PREFCOLORS, prefColorsDesc);
	DDX_Text(pDX, IDC_GRAPHS, graphsDesc);
}


BEGIN_MESSAGE_MAP(CPPgStats, CPropertyPage)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_ACSTAT, OnEnChangeACStats)
	ON_CBN_SELCHANGE(IDC_COLORSELECTOR, OnCbnSelchangeColorselector)
    ON_MESSAGE(CPN_SELCHANGE, OnSelChange)
	ON_BN_CLICKED(IDC_COLOR_BUTTON, OnBnClickedColorButton)
	ON_CBN_SELCHANGE(IDC_RATIO, OnCbnSelchangeRatio)
END_MESSAGE_MAP()


BOOL CPPgStats::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	for (int i = 0; i < 12; i++) {
		statcolors[i] = theApp.glob_prefs->GetStatsColor(i);
	}

	updateIntervalSlider.SetRange(0,120,false);
	statisticsUpdateIntervalSlider.SetRange(4,120,false);
	averageGraphTimeSlider.SetRange(1,60,false);

	graphsUpdateInterval = app_prefs->GetTrafficOMeterInterval();
	statisticsUpdateInterval = app_prefs->GetStatsInterval();
	averageGraphTime = app_prefs->GetStatsAverageMinutes();
	
	acStat.Format(_T("%d"), app_prefs->GetStatsMax());
	
	ratioCombo.AddString(_T("1:1"));		// propstats Cax2
	ratioCombo.AddString(_T("1:2"));
	ratioCombo.AddString(_T("1:3"));
	ratioCombo.AddString(_T("1:4"));
	ratioCombo.AddString(_T("1:5"));
	ratioCombo.AddString(_T("1:10"));
	int n = app_prefs->GetGraphRatio();
	ratioCombo.SetCurSel((n==10)?5:n-1); // propstats Cax2

	colorButton.TrackSelection	= TRUE;
	Localize();
	UpdateData(FALSE);
	SetModified(FALSE);

	return TRUE;
}

BOOL CPPgStats::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		for (int i=0;i<12;i++) {
			theApp.glob_prefs->SetStatsColor(i,statcolors[i]);
		}
		theApp.glob_prefs->SetTrafficOMeterInterval(graphsUpdateInterval);
		theApp.glob_prefs->SetStatsInterval(statisticsUpdateInterval);
		theApp.glob_prefs->SetStatsAverageMinutes(averageGraphTime);
		int n = ratioCombo.GetCurSel();
		app_prefs->SetGraphRatio((n==5)?10:n+1);	// propstats Cax2
		theApp.emuledlg->statisticswnd.Localize();
		theApp.emuledlg->statisticswnd.ShowInterval();
				
		if(app_prefs->GetStatsMax() > app_prefs->GetMaxConnections())
		{
			app_prefs->SetStatsMax(app_prefs->GetMaxConnections());
			acStat.Format(_T("%d"), app_prefs->GetStatsMax());			
		} else {
			app_prefs->SetStatsMax(_tstoi(acStat));
		}

		UpdateData(FALSE);

		theApp.emuledlg->statisticswnd.UpdateActConScale();
		theApp.emuledlg->statisticswnd.RepaintMeters();

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgStats::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		graphsDesc = GetResString(IDS_GRAPHS);
		streeDesc = GetResString(IDS_STREE);
		acStatDesc = GetResString(IDS_ACSTAT_LBL);
		acRatioDesc = GetResString(IDS_ACRATIO_LBL);
		SetWindowText(GetResString(IDS_STATSSETUPINFO));

		prefColorsDesc = GetResString(IDS_COLORS);

		colorsCombo.ResetContent();
		colorsCombo.AddString(GetResString(IDS_SP_BACKGROUND));
		colorsCombo.AddString(GetResString(IDS_SP_GRID));
		colorsCombo.AddString(GetResString(IDS_SP_DL1));
		colorsCombo.AddString(GetResString(IDS_SP_DL2));
		colorsCombo.AddString(GetResString(IDS_SP_DL3));
		colorsCombo.AddString(GetResString(IDS_SP_UL1));
		colorsCombo.AddString(GetResString(IDS_SP_UL2));
		colorsCombo.AddString(GetResString(IDS_SP_UL3));
		colorsCombo.AddString(GetResString(IDS_SP_ACTCON));
		colorsCombo.AddString(GetResString(IDS_SP_ACTUL));
		colorsCombo.AddString(GetResString(IDS_SP_ACTDL));
		colorsCombo.SetCurSel(0);

		UpdateData(FALSE);

		ShowInterval();
		colorButton.CustomText = GetResString(IDS_COL_MORECOLORS);
		colorButton.DefaultText = GetResString(IDS_COL_AUTOMATIC);
		OnCbnSelchangeColorselector();
	}
}

void CPPgStats::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	UpdateData(TRUE);

	ShowInterval();

	
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPPgStats::ShowInterval() {
		
	if (graphsUpdateInterval == 0) 
		graphUpdateIntervalDesc.Format(GetResString(IDS_DISABLED));
	else 
		graphUpdateIntervalDesc.Format(GetResString(IDS_STATS_UPDATELABEL), graphsUpdateInterval);
	
	if (statisticsUpdateInterval == 0)
		statisticsUpdateIntervalDesc.Format(GetResString(IDS_DISABLED));
	else
		statisticsUpdateIntervalDesc.Format(GetResString(IDS_STATS_UPDATELABEL), statisticsUpdateInterval);
	
	avgGraphDesc.Format(GetResString(IDS_STATS_AVGLABEL), averageGraphTime);	

	UpdateData(FALSE); 
}

void CPPgStats::OnCbnSelchangeColorselector()
{
	colorButton.SetColor((COLORREF) statcolors[colorsCombo.GetCurSel()]);
	colorButton.SetDefaultColor(app_prefs->DefaultStatsColor(colorsCombo.GetCurSel()));
}

LONG CPPgStats::OnSelChange(UINT newColor, LONG /*wParam*/)
{
	statcolors[colorsCombo.GetCurSel()]=(COLORREF) newColor;
	SetModified(TRUE);
	return TRUE;
}

