// #zegzav:pastcomment

#include "stdafx.h"
#include "emule.h"
#include "PastComment.h"

static const CString strPastCommentNul(_T(""));

CPastComment::CPastComment() : m_nRate(0)
{
	memset(m_ClientHash, 0, 16);
}

CPastComment::CPastComment(uchar client[16]) : m_nRate(0)
{
	#ifndef AMD
	md4cpy(m_ClientHash, client);
	#else
	memcpy_amd(m_ClientHash, client, 16);
	#endif
}

CPastComment::CPastComment(uchar client[16], const CString &strClientName) : m_nRate(0), m_strClientName(strClientName)
{
	#ifndef AMD
	md4cpy(m_ClientHash, client);
	#else
	memcpy_amd(m_ClientHash, client, 16);
	#endif
}

CPastComment::CPastComment(uchar client[16], const CString &strClientName, const CString &strFileName, const CString &strComment, int8 nRate) : 
	m_strClientName(strClientName), m_strFileName(strFileName), m_strComment(strComment), m_nRate(nRate)
{ 
	#ifndef AMD
	md4cpy(m_ClientHash, client);
	#else
	memcpy_amd(m_ClientHash, client, 16);
	#endif
}

bool CPastComment::operator==(const CPastComment &pc) const
{
	return (md4cmp(m_ClientHash, pc.m_ClientHash) == 0);
}

bool CPastCommentList::GetCommentRate(uchar client[16], CString *pstrComment, int8 *pnRate) const
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
	{
		*pstrComment= _T("");
		*pnRate= 0;
		return false;
	}
	CPastComment pc= GetAt(pos);
	*pstrComment= pc.GetComment();
	*pnRate= pc.GetRate();
	return true;
}

const CString &CPastCommentList::GetFileName(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return strPastCommentNul;
	return GetAt(pos).GetFileName();
}

const CString &CPastCommentList::GetComment(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return strPastCommentNul;
	return GetAt(pos).GetComment();
}

int8 CPastCommentList::GetRate(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return 0;
	return GetAt(pos).GetRate();
}

void CPastCommentList::Add(uchar client[16], const CString &strClientName, const CString &strFileName, const CString &strComment, int8 nRate)
{
	POSITION pos;
	CPastComment pc(client, strClientName, strFileName, strComment, nRate);
	if ((pos= Find(pc)) == NULL)
		AddTail(pc);
	else
		SetAt(pos, pc);
}

void CPastCommentList::Remove(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return;
	RemoveAt(pos);
}

