//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// ServerListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerListCtrl.h"
#include "Sockets/EmEngine.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CServerListCtrl

IMPLEMENT_DYNAMIC(CServerListCtrl, CMuleListCtrl/*CTreeCtrl*/)
CServerListCtrl::CServerListCtrl(){
	memset(&asc_sort,0,13);
	server_list = 0; // i_a 
}

bool CServerListCtrl::Init(CServerList* in_list){ 
	ModifyStyle(0,TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS);
	// Set Imagelist
	server_list = in_list;
	imagelist.Create(16,16,ILC_COLOR32|ILC_MASK,0,10); // changed by FoRcHa + Cax2 - highlight bugfix
	imagelist.SetBkColor(CLR_NONE);		//Cax2 - highlight bugfix
	imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SMALLSERVER),16,16)); // changed by FoRcHa 
	LoadImgLstIcon(NULL,0,0); // delete temp-icon

	SetImageList(&imagelist,LVSIL_SMALL);//TVSIL_NORMAL);
	ModifyStyle(LVS_SINGLESEL|LVS_LIST|LVS_ICON|LVS_SMALLICON,LVS_REPORT); //here the CListCtrl is set to report-style
	SetExtendedStyle(LVS_EX_FULLROWSELECT);

	InsertColumn(0,GetResString(IDS_SL_SERVERNAME),LVCFMT_LEFT, 150);
	InsertColumn(1,GetResString(IDS_IP),LVCFMT_LEFT, 140);
	InsertColumn(2,GetResString(IDS_DESCRIPTION) ,LVCFMT_LEFT, 150);
	InsertColumn(3,GetResString(IDS_PING),LVCFMT_RIGHT, 50);
	CString temp;
	temp.Format(_T("%s (%s)"), GetResString(IDS_UUSERS), GetResString(IDS_MAXUSERS));
	InsertColumn(4,temp,LVCFMT_RIGHT, 50);
	InsertColumn(5,GetResString(IDS_FILES) ,LVCFMT_RIGHT, 50);
	InsertColumn(6,GetResString(IDS_PRIORITY),LVCFMT_LEFT, 60);
	InsertColumn(7,GetResString(IDS_UFAILED),LVCFMT_RIGHT, 50);
	InsertColumn(8,GetResString(IDS_STATICSERVER),LVCFMT_LEFT, 50);
	InsertColumn(9,GetResString(IDS_SERVER_SOFTHARDLIMIT),LVCFMT_RIGHT, 100);
	InsertColumn(10,GetResString(IDS_SERVER_VERSION),LVCFMT_LEFT, 150);

	asc_sort[4]=true;asc_sort[5]=true;asc_sort[7]=true;// Changed by Cax2 
	asc_sort[9]=true;asc_sort[10]=true;

	LoadSettings(CPreferences::tableServer);
	//sortdlg Cax2
	if (theApp.glob_prefs->DoUseSort())	SortInit(theApp.glob_prefs->GetServerSortCol());//Cax2 sortdlg
	else SortInit(3);
	return true;
} 

// v- eklmn: bugfix(01): resource cleanup due to ImageLists recreation
void CServerListCtrl::OnDestroy() {
	imagelist.DeleteImageList();
}
// ^- eklmn: bugfix(01): resource cleanup due to ImageLists recreation

CServerListCtrl::~CServerListCtrl() {
}

void CServerListCtrl::SortInit(int sortCode){	//Cax2 sortdlg
	int m_CurrentSortItem=(sortCode<100)?sortCode:sortCode-100;
	if (sortCode==54||sortCode==154)
		SetSortArrow(4,(sortCode==54)? arrowDoubleUp:arrowDoubleDown);
	else if (sortCode==59||sortCode==159)
		SetSortArrow(9,(sortCode==59)? arrowDoubleUp:arrowDoubleDown);
	else SetSortArrow(m_CurrentSortItem,(sortCode<100));

	SortItems(&SortProc, sortCode);
}

void CServerListCtrl::Localize() 
{
	if(GetSafeHwnd())
	{
	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	CString strRes;

	strRes = GetResString(IDS_SL_SERVERNAME);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(0, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_IP);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(1, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DESCRIPTION);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(2, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_PING);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(3, &hdi);
	strRes.ReleaseBuffer();

 
	strRes.Format(_T("%s (%s)"), GetResString(IDS_UUSERS), GetResString(IDS_MAXUSERS));
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(4, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_FILES);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(5, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_PRIORITY);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(6, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_UFAILED);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(7, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_STATICSERVER);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(8, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_SERVER_SOFTHARDLIMIT);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(9, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_SERVER_VERSION);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(10, &hdi);
	strRes.ReleaseBuffer();
	}
}

/*void CServerListCtrl::ShowServers(){ 
   DeleteAllItems(); 
   int i=0; 
   CString temp; 
   for(POSITION pos = server_list->list.GetHeadPosition(); pos != NULL;server_list->list.GetNext(pos)) { 
      CServer* cur_server = server_list->list.GetAt(pos); 
      InsertItem(LVIF_TEXT|LVIF_PARAM,i,cur_server->GetListName(),0,0,0,(LPARAM)cur_server);
	  RefreshServer( cur_server );
      i++; 
   } 
}
*/

int CServerListCtrl::FindIndex(const CServer* server) const {
	
	LVFINDINFO find;
	::ZeroMemory(&find,sizeof(LVFINDINFO));
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)server;
	return FindItem(&find);
}


void CServerListCtrl::RefreshServerDesc(int itemnr, const CServer& server ){

	CString temp;
	temp.Format(_T("%s : %i"),server.GetAddress(),server.GetPort());
	SetItemText(itemnr, 1, temp);
	if(server.GetListName()){
		SetItemText(itemnr, 0, server.GetListName());
	}
	if(server.GetDescription()){
		SetItemText(itemnr,2,server.GetDescription());
	}
	if(server.GetPing()){
		temp.Format(_T("%i"),server.GetPing()); 
		SetItemText(itemnr,3,temp);
	}
	if(server.GetUsers()){
		if( server.GetMaxUsers() )
			temp.Format(_T("%i (%i)"),server.GetUsers(),server.GetMaxUsers());
		else
		temp.Format(_T("%i"),server.GetUsers()); 
		SetItemText(itemnr,4,temp);
	}
	if(server.GetFiles()){
		temp.Format(_T("%i"),server.GetFiles()); 
		SetItemText(itemnr,5,temp);
	}
	switch(server.GetPreferences()){
		case PR_LOW:
			SetItemText(itemnr,6,GetResString(IDS_PRIOLOW));
			break;
		case PR_NORMAL:
			SetItemText(itemnr,6,GetResString(IDS_PRIONORMAL));
			break;
		case PR_HIGH:
			SetItemText(itemnr,6,GetResString(IDS_PRIOHIGH));
			break;
		default:
			SetItemText(itemnr,6,GetResString(IDS_PRIONOPREF));
	}
	
	temp.Format(_T("%i"),server.GetFailedCount()); 
	SetItemText(itemnr,7,temp);
	
	if (server.IsStaticMember())
		SetItemText(itemnr,8,GetResString(IDS_YES)); 
	else
		SetItemText(itemnr,8,GetResString(IDS_NO));

	if (server.GetHardFiles())
	{
		if (server.GetSoftFiles())
			temp.Format(_T("%i (%i)"), server.GetSoftFiles(), server.GetHardFiles());
		else
			temp.Format(_T("(%i)"), server.GetHardFiles());
		SetItemText(itemnr,9,temp);
	}

	SetItemText(itemnr,10,server.GetVersion());
}

void CServerListCtrl::RemoveServer(CServer* todel,bool bDelToList){
	
	int result = FindIndex(todel);
	
	if (result != -1 ){
		server_list->RemoveServer((CServer*)GetItemData(result));
		DeleteItem(result); 
	}
	ShowFilesCount();
	return;
}

// Remove Dead Servers
void CServerListCtrl::RemoveDeadServer(){
	if( theApp.glob_prefs->DeadServer() ){
	   ShowWindow(SW_HIDE); 
#ifndef USE_SAFE_ARRAY
		for(POSITION pos = server_list->list.GetHeadPosition(); pos != NULL;server_list->list.GetNext(pos)) { 
			CServer* cur_server = server_list->list.GetAt(pos); 
			if( cur_server->GetFailedCount() > theApp.glob_prefs->GetDeadserverRetries() &&
				!cur_server->IsStaticMember()){
				RemoveServer(cur_server);
				pos = server_list->list.GetHeadPosition();
			}
		}
#else
	   for ( INT_PTR pos = 0; pos < server_list->array.GetCount(); pos++ )
	   {
			CServer* cur_server = server_list->GetServerAt(pos); 
			if( cur_server->GetFailedCount() > theApp.glob_prefs->GetDeadserverRetries() &&
				!cur_server->IsStaticMember()){
				RemoveServer(cur_server);
				pos = 0;
			}
	   }
#endif
	   ShowWindow(SW_SHOW); 
	}
}

void CServerListCtrl::AppendServer(CServer* server) {
	
	int itemnr = GetItemCount();
	itemnr = InsertItem(LVIF_TEXT|LVIF_PARAM,itemnr,server->GetListName(),0,0,1,(LPARAM)server);
	if( server->GetFailedCount() < 0 )
		server->ResetFailedCount();
	RefreshServerDesc(itemnr, *server);
}

bool CServerListCtrl::AddServer(CServer* toadd,bool bAddToList, bool bulkLoad)
{
	if (toadd == NULL) return false;	//eklmn: check NULL case at server addition

	if (!server_list->AddServer(toadd)) return false;

   if (bAddToList)    
	   AppendServer(toadd);	   
   if (!bulkLoad)
	   ShowFilesCount();
   return true; 
}


void CServerListCtrl::RefreshServer(CServer& server ){

	if (!::IsWindow(m_hWnd))
		return;
	
	int itemnr = FindIndex(&server);
	if (itemnr == -1)
		return;

	if( server.GetFailedCount() < 0 )
		server.ResetFailedCount();
	RefreshServerDesc(itemnr, server);
}

BEGIN_MESSAGE_MAP(CServerListCtrl, CMuleListCtrl/*CTreeCtrl*/) 
  // ON_NOTIFY_REFLECT(NM_RCLICK, OnNMRclickServlist) 
   ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnLvnColumnclickServlist) 
   ON_NOTIFY_REFLECT (NM_DBLCLK, OnNMLdblclk) //<-- mod bb 27.09.02 
   ON_WM_CONTEXTMENU()
   ON_WM_DESTROY()	// eklmn: bugfix(01): resource cleanup due to ImageLists recreation
END_MESSAGE_MAP()

// CServerListCtrl message handlers

void CServerListCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{ 
//	POINT point; 
//	::GetCursorPos(&point); 

	// tecxx 0609 2002 
	// fix - on right click, we also want to change the current selection like the left click does 
	CPoint p = point; 
	ScreenToClient(&p); 
	int it = HitTest(p); 
	if (it != -1) 
		SetSelectionMark(it);   // display selection mark correctly! 
	// fix end 

	// Create up-to-date popupmenu
	UINT flags;	//,flagSSL1,flagSSL2;
	CTitleMenu m_ServerMenu;
	CMenu m_ServerPrioMenu;

	CServer* test=NULL;
	if (GetSelectionMark() != -1) test=(CServer*)GetItemData(GetSelectionMark());

	// set state of selection-dependent menuitems
	flags=MF_STRING || MF_DISABLED;
	if (GetSelectionMark() != (-1) && GetSelectedCount()>0)
		if (test != NULL)
			flags=MF_STRING;
	//flagSSL1=MF_STRING || MF_DISABLED;
	//flagSSL2=MF_STRING || MF_DISABLED;
	//if (test != NULL && GetSelectedCount()>0) 
	//	if (test->IsStaticMember()) flagSSL2=MF_STRING; else flagSSL1=MF_STRING;
	   
	m_ServerPrioMenu.CreateMenu();
	m_ServerPrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
	m_ServerPrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
	m_ServerPrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH,GetResString(IDS_PRIOHIGH));

	m_ServerMenu.CreatePopupMenu(); 
	m_ServerMenu.AddMenuTitle(GetResString(IDS_EM_SERVER));
	m_ServerMenu.AppendMenu(flags,MP_CONNECTTO, GetResString(IDS_CONNECTTHIS)); 
	m_ServerMenu.AppendMenu(flags|MF_POPUP,(UINT_PTR)m_ServerPrioMenu.m_hMenu, GetResString(IDS_PRIORITY));

	//SyruS hide greyed-out "add /remove from static server"
	if (test != NULL && GetSelectedCount()>0)
		if (test->IsStaticMember()) 
			m_ServerMenu.AppendMenu(flags,MP_REMOVEFROMSTATIC, GetResString(IDS_REMOVEFROMSTATIC));
		else
			m_ServerMenu.AppendMenu(flags,MP_ADDTOSTATIC, GetResString(IDS_ADDTOSTATIC));

	m_ServerMenu.AppendMenu(MF_STRING|MF_SEPARATOR);	
	m_ServerMenu.AppendMenu(flags,MP_REMOVE, GetResString(IDS_REMOVETHIS)); 
	m_ServerMenu.AppendMenu(MF_STRING,MP_REMOVEALL, GetResString(IDS_REMOVEALL));
	m_ServerMenu.AppendMenu(MF_SEPARATOR); 
	m_ServerMenu.AppendMenu(flags,MP_GETED2KLINK, GetResString(IDS_DL_LINK1));
	// m_ServerMenu.AppendMenu(MF_STRING,Irc_SetSendLink, GetResString(IDS_IRC_ADDLINKTOIRC)); 

	m_ServerMenu.SetDefaultItem(MP_CONNECTTO);
	m_ServerMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this); 

	m_ServerPrioMenu.DestroyMenu(); // Added by Tarod -leak fix
	m_ServerMenu.DestroyMenu();

//	*pResult = 0; 
}

BOOL CServerListCtrl::OnCommand(WPARAM wParam,LPARAM lParam ){ 
   int item= GetSelectionMark(); 

   if (wParam==MP_REMOVEALL)
   { 
#ifdef OLD_SOCKETS_ENABLED
	if( theApp.serverconnect->IsConnecting() )
	{
	   	theApp.downloadqueue->StopUDPRequests(); 
		theApp.serverconnect->StopConnectionTry();
		theApp.serverconnect->Disconnect();
		theApp.emuledlg->ShowConnectionState(false);
	}
#endif //OLD_SOCKETS_ENABLED
	ShowWindow(SW_HIDE);
	server_list->RemoveAllServers(); 
	DeleteAllItems();
	ShowWindow(SW_SHOW);
	   ShowFilesCount();
	return true;
   }

   if (item != -1){ 
      if (((CServer*)GetItemData(GetSelectionMark())) != NULL){ 

		  switch (wParam){ 
            case MP_CONNECTTO: 
			{
				if ( GetSelectedCount()>1 ) {
					CServer* aServer;
					uint32   newPosition=0;

#ifdef OLD_SOCKETS_ENABLED
					theApp.serverconnect->Disconnect();
#endif //OLD_SOCKETS_ENABLED
					POSITION pos=GetFirstSelectedItemPosition();
					// Move selected servers to the liststart, to connect them first
					while (pos!=NULL )
					{ 
						item = GetNextSelectedItem(pos); 
						if (item>-1) {
							aServer=(CServer*)this->GetItemData(item);
							theApp.serverlist->MoveServerDown(aServer);
						}
					} 
#ifdef OLD_SOCKETS_ENABLED
					theApp.serverconnect->ConnectToAnyServer( (theApp.serverlist->GetServerCount() - GetSelectedCount()), false);
#else
					theApp.pEngine->ConnectToAnyServer();
#endif //OLD_SOCKETS_ENABLED
				} else {
					// DonGato - 25/10/2002 
#ifdef OLD_SOCKETS_ENABLED
					if (theApp.serverconnect->IsConnected()){       
						if (!_tcscmp(((CServer*)GetItemData(GetSelectionMark()))->GetAddress(), (theApp.serverconnect->GetCurrentServer())->GetAddress())){ 
							AddLogLine( false, IDS_ALREADYCONNECTED, ((CServer*)GetItemData(GetSelectionMark()))->GetListName()); 
							break; 
						} 
					}                       
					// 
					theApp.serverconnect->ConnectToServer(*(CServer*)GetItemData(GetSelectionMark()));
#endif //OLD_SOCKETS_ENABLED
#ifdef NEW_SOCKETS
					CServer *pServer = (CServer*)GetItemData(GetSelectionMark());
					if(pServer)
						theApp.pEngine->ConnectToServer(pServer);
#endif //NEW_SOCKETS
				}
				theApp.emuledlg->ShowConnectionState(false);
			    break; 
			}			
    		        case MP_REMOVE: 
            		{ 
				ShowWindow(SW_HIDE); 
				POSITION pos;
				while (GetFirstSelectedItemPosition()!=NULL) //(pos != NULL) 
				{ 
					pos=GetFirstSelectedItemPosition();
					item = GetNextSelectedItem(pos); 
					server_list->RemoveServer((CServer*)GetItemData(item));
					DeleteItem(item);
				}
				ShowFilesCount();
				ShowWindow(SW_SHOW); 
				break; 
		        }
			case MP_ADDTOSTATIC:{
				POSITION pos=GetFirstSelectedItemPosition();
				while( pos != NULL ){
					CServer* change = (CServer*)GetItemData(this->GetNextSelectedItem(pos));
					if (!StaticServerFileAppend(change))
						return false;
					change->SetIsStaticMember(true);
					theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*change);
				}
				break;
			}
			// Remove Static Servers [Barry]
			case MP_REMOVEFROMSTATIC:
				{
				POSITION pos=GetFirstSelectedItemPosition();
				while( pos != NULL ){
					CServer* change = (CServer*)GetItemData(this->GetNextSelectedItem(pos));
					if (!StaticServerFileRemove(change))
						return false;
					change->SetIsStaticMember(false);
					theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*change);
				}
				break;
			}
			case MP_PRIOLOW:
			{
				POSITION pos = GetFirstSelectedItemPosition();
				while( pos != NULL ){
					CServer* change = (CServer*)this->GetItemData(this->GetNextSelectedItem(pos));
					change->SetPreference(CServer::ePR_LOW);
					if (change->IsStaticMember())
						StaticServerFileAppend(change);
					theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*change);
					POSITION pos = this->GetFirstSelectedItemPosition();
				}
				break;
			}
			case MP_PRIONORMAL:
			{
				POSITION pos = GetFirstSelectedItemPosition();
				while( pos != NULL ){
					CServer* change = (CServer*)this->GetItemData(this->GetNextSelectedItem(pos));
					change->SetPreference(CServer::ePR_NORMAL);
					if (change->IsStaticMember())
						StaticServerFileAppend(change);
					theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*change);
					POSITION pos = this->GetFirstSelectedItemPosition();
				}
				break;
			}
			case MP_PRIOHIGH:
			{
				POSITION pos = GetFirstSelectedItemPosition();
				while( pos != NULL ){
					CServer* change = (CServer*)this->GetItemData(this->GetNextSelectedItem(pos));
					change->SetPreference(CServer::ePR_HIGH);
					if (change->IsStaticMember())
						StaticServerFileAppend(change);
					theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*change);
					POSITION pos = this->GetFirstSelectedItemPosition();
				}
				break;
			}
			case MP_GETED2KLINK: 
			{ 
				POSITION pos = GetFirstSelectedItemPosition(); 
				CString buffer, link; 
				while( pos != NULL ){ 
					CServer* change = (CServer*)this->GetItemData(GetNextSelectedItem(pos)); 
					buffer.Format(_T("ed2k://|server|%s|%d|/"), change->GetFullIP(), change->GetPort()); 
					if (link.GetLength()>0) buffer=_T("\n")+buffer;
					link += buffer; 
					POSITION pos = GetFirstSelectedItemPosition(); 
				} 
				theApp.CopyTextToClipboard(link); 
				break; 
			}
			case Irc_SetSendLink:
			{
				POSITION pos = GetFirstSelectedItemPosition(); 
				CString buffer, link; 
				while( pos != NULL ){ 
					CServer* change = (CServer*)this->GetItemData(GetNextSelectedItem(pos)); 
					buffer.Format(_T("ed2k://|server|%s|%d|/"), change->GetFullIP(), change->GetPort()); 
					if (link.GetLength()>0) buffer=_T("\n")+buffer;
					link += buffer; 
					POSITION pos = GetFirstSelectedItemPosition(); 
         			} 
				theApp.emuledlg->ircwnd.SetSendFileString(link);
				break;
      			} 

         } 
      } 
   } 
   return true; 
}

// DonGato - 25/10/2002 
void CServerListCtrl::OnNMLdblclk(NMHDR *pNMHDR, LRESULT *pResult){ 
	if (GetSelectionMark() != (-1))
	{
#ifdef OLD_SOCKETS_ENABLED
      	if (theApp.serverconnect->IsConnected())
		{     
			if (!_tcscmp(((CServer*)GetItemData(GetSelectionMark()))->GetAddress(), (theApp.serverconnect->GetCurrentServer())->GetAddress()))
			{ 
            		AddLogLine( false, IDS_ALREADYCONNECTED, ((CServer*)GetItemData(GetSelectionMark()))->GetListName()); 
            		return; 
			} 
		} 
		theApp.serverconnect->ConnectToServer(*(CServer*)GetItemData(GetSelectionMark())); 
#endif //OLD_SOCKETS_ENABLED
#ifdef NEW_SOCKETS
	CServer *pServer = (CServer*)GetItemData(GetSelectionMark());
	if(pServer)
		theApp.pEngine->ConnectToServer(pServer);
#endif //NEW_SOCKETS
	   	theApp.emuledlg->ShowConnectionState(false);
	}
}

bool CServerListCtrl::AddServermetToList(CString strFile) 
{ 
   SetRedraw(false);
   bool flag=server_list->AddServermetToList(strFile);
   RemoveDeadServer();
   ShowFilesCount();
   SetRedraw(true);
   return flag;
}

void CServerListCtrl::OnLvnColumnclickServlist(NMHDR *pNMHDR, LRESULT *pResult) 
{ 
   NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR; 
   int adder=0; //Cax2 - adapted from double arrows code in shared files control...
   if (pNMListView->iSubItem==4){
		if(asc_sort[4]) asc_sort[11]=!asc_sort[11];
		adder= asc_sort[11]?0:50;
   }
   if (pNMListView->iSubItem==9){
		if(asc_sort[9]) asc_sort[12]=!asc_sort[12];
		adder= asc_sort[12]?0:50;
   }
   // if it's a second click on the same column then reverse the sort order, 
   // otherwise sort the new column in ascending order. 
   asc_sort[pNMListView->iSubItem] = !asc_sort[pNMListView->iSubItem]; 
   if (adder==0) SetSortArrow(pNMListView->iSubItem, asc_sort[pNMListView->iSubItem]);//Cax2 double arrows
   else SetSortArrow(pNMListView->iSubItem,asc_sort[pNMListView->iSubItem] ? arrowDoubleUp:arrowDoubleDown);// double arrows
   SortItems(&SortProc,pNMListView->iSubItem+adder+((asc_sort[pNMListView->iSubItem])? 0:100)); // double arrows
   Invalidate(); 
   *pResult = 0; 
} 

int CServerListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){ 
   CServer* item1 = (CServer*)lParam1; 
   CServer* item2 = (CServer*)lParam2; 
   if((item1 == NULL) || (item2 == NULL)) return 0; 
   int iTemp=0; 
   int counter1; 
   int counter2; 
    
   int mod=1; //<<--New by Cax2 03/11/02 
   //most of this switch satement modified by Cax2 21/12/02
   switch(lParamSort){ 
     case 100: //Server-name desc 
        mod=-1; 
     case 0: {//(List) Server-name asc { 
        bool noname1=_tcsstr(item1->GetListName(),item1->GetFullIP()); 
        bool noname2=_tcsstr(item2->GetListName(),item2->GetFullIP()); 
        if(!noname1 && !noname2)                
         return _tcsicmp(item1->GetListName(),item2->GetListName())*mod;    
      else return noname1?(noname2?0:2):-1; 
           } 
      case 1:{ //IP asc //corrected by Cax2 12/12/02 - dynIp put before 1.1.1.1
		if( item1->HasDynIP() && item2->HasDynIP() )
			return CString(item1->GetDynIP()).CompareNoCase(item2->GetDynIP());
		if(item1->HasDynIP()) return -1;
		if(item2->HasDynIP()) return 1;
		CString sIP1, sIP2, sTemp1, sTemp2; 
		counter1 = counter2 = iTemp = 0; 
		sIP1 = item2->GetFullIP(); 
		sIP2 = item1->GetFullIP(); 
		for(int i=0; iTemp == 0 ; i++){ 
			sTemp1 = sIP1.Tokenize(_T("."),counter1);
			sTemp2 = sIP2.Tokenize(_T("."),counter2);
			iTemp = _tstoi(sTemp2) - _tstoi(sTemp1);
			if(i>2)	return item1->GetPort()-item2->GetPort(); 
		} 
		return iTemp; 
	  }
      case 101:{ //IP desc 
		if( item1->HasDynIP() && item2->HasDynIP() )
			return CString(item2->GetDynIP()).CompareNoCase(item1->GetDynIP());
		if(item1->HasDynIP()) return 1;
		if(item2->HasDynIP()) return -1;
		CString s2IP1, s2IP2, s2Temp1, s2Temp2; 
		counter1 = counter2 = iTemp = 0; 
		s2IP1 = item2->GetFullIP(); 
		s2IP2 = item1->GetFullIP(); 
		for(int i=0; iTemp == 0 ; i++){ 
			s2Temp1 = s2IP1.Tokenize(_T("."),counter1);
			s2Temp2 = s2IP2.Tokenize(_T("."),counter2); 
			iTemp = _tstoi(s2Temp1) - _tstoi(s2Temp2); 
			if(i>2) return item2->GetPort() - item1->GetPort(); 
		}
		return iTemp; 
	  }
      case 2: //Description asc //corrected by Cax2		    
		return item1->GetDescription().CompareNoCase(item2->GetDescription());
      case 102: //Desciption desc 
		return CString(item2->GetDescription()).CompareNoCase(item1->GetDescription());
	  case 3: //Ping asc 
		if (item1->GetPing()>0 && item2->GetPing()>0) 
			return item1->GetPing() - item2->GetPing(); 
		else return(item2->GetPing()>0)?2:((item1->GetPing()>0)?-1:0); 
	  case 103: //Ping desc 
		return item2->GetPing() - item1->GetPing(); 
      case 4: //Users asc 
		if (item1->GetUsers()>0 && item2->GetUsers()>0) 
			return item1->GetUsers() - item2->GetUsers(); 
		else return(item2->GetUsers()>0)?2:((item1->GetUsers()>0)?-1:0);
      case 104: //Users desc 
		return item2->GetUsers() - item1->GetUsers();
      case 54: //max. users
		  if(item1->GetMaxUsers() == item2->GetMaxUsers())
			  return 0;
		  if(item1->GetMaxUsers() == 0)
			  return 1;
		  if(item2->GetMaxUsers() == 0)
			  return -1;
		  return item1->GetMaxUsers() - item2->GetMaxUsers(); 
	  case 154: //Cax2 patch 21/12/02
		 return item2->GetMaxUsers() - item1->GetMaxUsers();
	  case 5: //Files asc 
		if (item1->GetFiles()>0 && item2->GetFiles()>0) 
			return item1->GetFiles() - item2->GetFiles(); 
		else return(item2->GetFiles()>0)?2:((item1->GetFiles()>0)?-1:0); 
      case 105: //Files desc 
		return item2->GetFiles() - item1->GetFiles(); 
	//end Cax2 modifications
		case 6: //Preferences asc 
		  return item1->GetPreferences() - item2->GetPreferences(); 
      case 106: //Preferences desc 
         return item2->GetPreferences() - item1->GetPreferences(); 
      case 7: //failed asc 
         return item1->GetFailedCount() - item2->GetFailedCount(); 
      case 107: //failed desc 
		  return item2->GetFailedCount() - item1->GetFailedCount(); 
      case 8: //staticservers 
		  return item2->IsStaticMember() - item1->IsStaticMember(); 
      case 108: //staticservers-
		  return item1->IsStaticMember() - item2->IsStaticMember(); 
      case 9: //Soft files asc 
		if ((item1->GetSoftFiles()>0 && item2->GetSoftFiles()>0) || (item1->GetHardFiles()>0 && item2->GetHardFiles()>0))
			return item1->GetSoftFiles() - item2->GetSoftFiles(); 
		else return(item2->GetSoftFiles()>0)?2:((item1->GetSoftFiles()>0)?-1:0);
      case 109: //Soft files desc 
		return item2->GetSoftFiles() - item1->GetSoftFiles();
      case 59: //Hard files asc 
		if (item1->GetHardFiles()>0 && item2->GetHardFiles()>0) 
			return item1->GetHardFiles() - item2->GetHardFiles(); 
		else return(item2->GetHardFiles()>0)?2:((item1->GetHardFiles()>0)?-1:0);
      case 159: //Hard files desc 
		return item2->GetHardFiles() - item1->GetHardFiles();
      case 10: //Version asc 
		return item1->GetVersion().CompareNoCase(item2->GetVersion());
      case 110: //Version desc 
		return item2->GetVersion().CompareNoCase(item1->GetVersion());
      default: 
         return 0; 
   } 
}

bool CServerListCtrl::StaticServerFileAppend(CServer *server)
{
	try
	{
		// Remove any entry before writing to avoid duplicates
		StaticServerFileRemove(server);

		FILE* staticservers = _tfopen(theApp.glob_prefs->GetConfigDir() + CString(_T("staticservers.dat")), _T("a"));
		if (staticservers==NULL) 
		{
			AddLogLine( false, IDS_ERROR_SSF);
			return false;
		}
		
		if (fprintf(staticservers,
					"%s:%i,%i,%s\n",
					server->GetAddress(),
					server->GetPort(), 
					server->GetPreferences(),
					server->GetListName()) != EOF) 
		{
			if (!server->IsStaticMember()) // DonGato
				AddLogLine(false, _T("'%s:%i,%s' %s"), server->GetAddress(), server->GetPort(), server->GetListName(), GetResString(IDS_ADDED2SSF));
			server->SetIsStaticMember(true);
			theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*server);
		}

		fclose(staticservers);
	}
	catch (...)
	{
		return false;
	}
	return true;
}

bool CServerListCtrl::StaticServerFileRemove(CServer *server)
{
	try
	{
		if (!server->IsStaticMember())
			return true;

		CString strLine;
		CString strTest;
		char buffer[1024];
		int lenBuf = 1024;
		int pos;
		CString StaticFilePath = theApp.glob_prefs->GetConfigDir() + CString("staticservers.dat");
		CString StaticTempPath = theApp.glob_prefs->GetConfigDir() + CString("statictemp.dat");
		FILE* staticservers = _tfopen(StaticFilePath , _T("r"));
		FILE* statictemp = _tfopen(StaticTempPath , _T("w"));

		if ((staticservers == NULL) || (statictemp == NULL))
		{
			AddLogLine( false, IDS_ERROR_SSF);
			return false;
		}

		while (!feof(staticservers))
		{
			if (fgets(buffer, lenBuf, staticservers) == 0)
				break;

			strLine = buffer;

			// ignore comments or invalid lines
			if (strLine.GetAt(0) == '#' || strLine.GetAt(0) == '/')
			{
				fprintf(statictemp, buffer);
				continue;
			}
			if (strLine.GetLength() < 5)
			{
				fprintf(statictemp, buffer);
				continue;
			}

			// Only interested in "host:port"
			pos = strLine.Find(',');
			if (pos == -1)
				continue;
			strLine = strLine.Left(pos);

			// Get host and port from given server
			strTest.Format(_T("%s:%i"), server->GetAddress(), server->GetPort());

			// Compare, if not the same server write original line to temp file
			if (strLine.Compare(strTest) != 0)
				fprintf(statictemp, buffer);
		}

		fclose(staticservers);
		fclose(statictemp);

		// All ok, remove the existing file and replace with the new one
		CFile::Remove( StaticFilePath );
		CFile::Rename( StaticTempPath, StaticFilePath );

		//purity
		AddLogLine(false, _T("'%s:%i,%s' %s"), server->GetAddress(), server->GetPort(), server->GetListName(), GetResString(IDS_REMOVEDFROMSSF));
		server->SetIsStaticMember(false);
		theApp.emuledlg->serverwnd.serverlistctrl.RefreshServer(*server);
	}
	catch (...)
	{
		return false;
	}
	return true;
}

void CServerListCtrl::ShowFilesCount() {
	CString counter;

	counter.Format(_T(" (%i)"), GetItemCount());
	theApp.emuledlg->serverwnd.GetDlgItem(IDC_SERVLIST_TEXT)->SetWindowText(GetResString(IDS_SV_SERVERLIST)+counter  );
}
