//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#pragma once
#include "UploadListCtrl.h"
#include "DownloadListCtrl.h"
#include "QueueListCtrl.h"
#include "InfoListCtrl.h"
#include "RollupCtrl.h"
#include "ResizableLib\ResizableDialog.h"
#include "ToolTips\PPToolTip.h"
#include "tabctrl.hpp"
#include "Tabs.h"
#include "Tabs2.h"
#include "afxcmn.h"

#define COLLAPSE_ONLY	0
#define EXPAND_ONLY		1
#define EXPAND_COLLAPSE	2

#define IDC_DOWNLOADLIST 124
#define IDC_UPLOADLIST	 125
#define IDC_QUEUELIST	 126

#define USRMSG_CLEARCOMPLETED	WM_USER + 5


class CDummyForTabs;

// CTransferWnd dialog

class CTransferWnd : public CResizableDialog
{
	DECLARE_DYNAMIC(CTransferWnd)

public:
	CTransferWnd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTransferWnd();
	void	Localize();
	
// Dialog Data
	enum { IDD = IDD_TRANSFER };
	long 	GetDetailColumnWidth()		//Cax2
	{
		return m_wndInfoList.GetColumn();
	}
	
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg BOOL OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult);
	void UpdateToolTips(void);
	int GetItemUnderMouse(CListCtrl* ctrl);
	DECLARE_MESSAGE_MAP()

private:
//	CString m_strToolTip;
	int m_iOldToolTipItemDown;
	int m_iOldToolTipItemUp;
	int m_iOldToolTipItemQueue;
	bool m_bFirstShow;

	POINT	m_pLastMousePoint;

	int m_nDragIndex;
	int m_nDropIndex;
	int m_nLastCatTT;
	bool m_bIsDragging;
	CImageList* m_pDragImage;
	int	m_iRightClickIndex;

public:
	int AddCategory(CString newtitle,CString newincoming,CString newcomment,CString newautocat,bool addTab=true);

private:
	void OnDblclickDltab();
	int GetTabUnderMouse(CPoint* point);
	CString GetTabStatistic(uint8 tab); 

public:
	CTabs m_wndDlTabs;
//	CTabs2 m_wndDlTabs;
	CToolTipCtrl* m_pttDlTabToolTips;
	
	CDummyForTabs* m_pwndDummyForDownloadList;

	CDownloadListCtrl m_wndDownloadList;
	CQueueListCtrl m_wndQueueList;
	UINT m_nActiveWnd;
	
	Cm_wndUploadList m_wndUploadList;
	CInfoListCtrl m_wndInfoList;
	CRollupCtrl m_wndRollup;
	//CToolTipCtrl m_ttip;
	CPPToolTip m_ttip;
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	void UpdateDownloadHeader();
	void UpdateUploadHeader();
	void UpdateInfoHeader();
	void InitRollupItemHeights();
	void SafeRollupItemHeights();
	void SwitchUploadList();
	afx_msg void OnDestroy();	// eklmn: bugfix(00): resource cleanup due to CResizableDialog

	void EditCatTabLabel(int index,CString newlabel);
	void UpdateCatTabTitles();
	void UpdateTabToolTips() {UpdateTabToolTips(-1);}
	void UpdateTabToolTips(int tab);

	afx_msg void OnTcnSelchangeDltab(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickDltab(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnBegindrag(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTabMovement(NMHDR *pNMHDR, LRESULT *pResult);
	
	void OnMouseMove(UINT nFlags, CPoint point);
	void OnLButtonUp(UINT nFlags, CPoint point);

protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
};
