//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "uploadqueue.h"
#include "packets.h"
#include "emule.h"
#include "knownfile.h"
#ifdef OLD_SOCKETS_ENABLED
#include "listensocket.h"
#endif //OLD_SOCKETS_ENABLED
#include "ini2.h"
#include "math.h"
#include "Smtp.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


static uint32 counter, sec,statsave;
// -khaos--+++> Added iupdateconnstats...
static uint32 igraph, istats, iupdateconnstats;
// <-----khaos-
VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
UINT SaveSourcesThread(HANDLE lpArg);

//TODO rewrite the whole networkcode, use overlapped sockets

CUploadQueue::CUploadQueue(CPreferences* in_prefs)
{
	EMULE_TRY

	app_prefs = in_prefs;
	m_bExiting	=	FALSE;
	h_timer = SetTimer(0,141,100,TimerProc);
	if (!h_timer)
		AddDebugLogLine(false,IDS_ERR_TIMERCREATEFAILED);
	estadatarate = 2000;
	datarate = 0;
	datarateave = 0;
	bannedcount = 0;
	counter=0;
//	sumavgdata = 0;				// enkeyDEV(Ottavio84) -Accurate speed measurement-
//	sendtimestamp = GetTickCount();	// enkeyDEV(Ottavio84) -Upload rate is made independent from the inaccurate WM_TIMER-
//	bDataRateMaxed = false; 		// Tarod [LoneStar]
//	lasttimechecked = GetTickCount() ;
	//eklmn: Extended Upload stats
	ULSession_Successfull = 0;
	ULSession_Successfull_FullChunk  = 0;
	for (int i=0; i<ETS_TERMINATOR; i++)
	{
		ULSession_Successfull_PartChunk[i]  = 0;
		ULSession_Failed[i] = 0;
	}
	totaluploadtime = 0;
	m_nUpDataRateMSOverhead = 0;
	m_nUpDatarateOverhead = 0;
	m_nUpDataOverheadSourceExchange = 0;
	m_nUpDataOverheadFileRequest = 0;
	m_nUpDataOverheadOther = 0;
	m_nUpDataOverheadServer = 0;
	m_nUpDataOverheadSourceExchangePackets = 0;
	m_nUpDataOverheadFileRequestPackets = 0;
	m_nUpDataOverheadOtherPackets = 0;
	m_nUpDataOverheadServerPackets = 0;
	statsave=0;
	// -khaos--+++>
	iupdateconnstats=0;
	// <-----khaos-
    for (int i = 0;i != 35;i++)
		activeClients_list.AddHead((int)0);

    m_MaxActiveClients = 0;

    leftoverBandwidth = 0;

    m_guessedMaxBandwidth = 300;
	m_guessedMaxLANBandwidth = 3000;

    m_lastGaveDataTick = ::GetTickCount();
    m_lastCalculatedDataRateTick = 0;
	// Create timer to save known sources each 30 min 
	m_hSaveSTimer	=	::CreateWaitableTimer(NULL,FALSE,NULL);
	if ( m_hSaveSTimer )
	{
		// Creade lower prioraty thread that will do the "job"
		m_pSaveThread	=	AfxBeginThread(SaveSourcesThread,(LPVOID)this,THREAD_PRIORITY_NORMAL+ theApp.glob_prefs->GetMainProcessPriority());
		if ( ! m_pSaveThread )
		{
			::CloseHandle(m_hSaveSTimer);
			m_hSaveSTimer	=	NULL;
			AddDebugLogLine(false,_T("Error creating SourcesSaveThread"));
		}
	}
	else
	{
		AddDebugLogLine(false,IDS_ERR_TIMERCREATEFAILED);
	}

	EMULE_CATCH2
}

void CUploadQueue::AddUpNextClient(CUpDownClient* directadd)
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (theApp.listensocket->TooManySockets()) return;
#endif //OLD_SOCKETS_ENABLED
	POSITION toadd = 0;
	uint32	bestscore = 0;
	CUpDownClient* newclient;
	// select next client or use given client
	if (!directadd){
		POSITION pos1, pos2;
		for (pos1 = waitinglist.GetHeadPosition();( pos2 = pos1 ) != NULL;){
			waitinglist.GetNext(pos1);
			CUpDownClient* cur_client =	waitinglist.GetAt(pos2);
			// clear dead clients
			ASSERT(cur_client->GetLastUpRequest()); 

			if (GetTickCount() - cur_client->GetLastUpRequest() > MAX_PURGEQUEUETIME
					|| !theApp.sharedfiles->GetFileByID(cur_client->reqfileid)) {   // [InterCeptor (remove "?" from queue) 15.11.02]
				RemoveFromWaitingQueue(pos2,true);
#ifdef OLD_SOCKETS_ENABLED
				if(!cur_client->socket)
					cur_client->Disconnected();
#endif //OLD_SOCKETS_ENABLED
				continue;	// eklmn: bugfix(17): upload fix(jump to next client)
			}
			// finished clearing
			else if ( (cur_client->GetScore(true) > bestscore) && (!cur_client->IsBanned()) 
				&& (!cur_client->HasLowID()
#ifdef OLD_SOCKETS_ENABLED
				|| (cur_client->socket && cur_client->socket->IsConnected()) 
#endif //OLD_SOCKETS_ENABLED
				) ){
				bestscore = cur_client->GetScore(true);
				toadd = pos2;
			}
		}
		if (!toadd)
			return;
		newclient = waitinglist.GetAt(toadd);
		RemoveFromWaitingQueue(toadd, true);
		theApp.emuledlg->transferwnd.UpdateUploadHeader(); // changed by FoRcHa
	}
	else
		newclient = directadd;

	if (IsDownloading(newclient) || newclient->IsBanned(true)) {	//SyruS never upload to a banned client
		return;
	}
	// tell the client that we are now ready to upload
#ifdef OLD_SOCKETS_ENABLED
	if (!newclient->socket || !newclient->socket->IsConnected()){
		newclient->SetUploadState(US_CONNECTING);
		if (!newclient->TryToConnect(true))	// SLUGFILLER: SafeDisconnect
			return;
	}
	else{
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		newclient->socket->SendPacket(packet,true);
		newclient->SetUploadState(US_UPLOADING);
		newclient->SetLastGotULData();	//eklmn: set Upload Timer
	}
#endif //OLD_SOCKETS_ENABLED
  // obaldin: bug found by dr.clone, but it could be deeper
  // let's put in the check for now
  if(!theApp.clientlist->Debug_IsValidClient(newclient))
  {
    AddDebugLogLine(false,_T("AddUpNextClient(): client not in ClientList"));
    return;
  }
	
/*
	if(ASK_FOR_PARTS_ON_UPLOAD)
		newclient->SendFileRequestForUpload();
*/
	newclient->SetUpStartTime();
	newclient->ResetSessionUp();
	newclient->ResetCompressionGain(); 	// Add show compression
	uploadinglist.AddTail(newclient);
	
	// statistic
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)newclient->reqfileid);
	if (reqfile)
		reqfile->statistic.AddAccepted();
	
	theApp.emuledlg->transferwnd.m_wndUploadList.AddClient(newclient);

	EMULE_CATCH
}

void CUploadQueue::Process()
{
	EMULE_TRY

    DWORD curTick = ::GetTickCount();
    int timeSinceLastGaveDataMs;

	// LANCAST (moosetea) - We count lanclients
	int QtyLANClients = 0;

    // after 49 days tick wraps around. I think this still handles it. (Yeah right! As if we wouldn't have crashed by then :))
    timeSinceLastGaveDataMs = curTick - m_lastGaveDataTick;

    // Keeps track of how much bandWidth we use this call
    sint32 usedBandwidthThisCall = 0;

    // How much data should be given each round?
	if(theApp.glob_prefs->GetMaxUpload() == UNLIMITED) {
        // Special case for unlimited upload

        if (AcceptNewClient(uploadinglist.GetCount()) && waitinglist.GetCount()) {
		    AddUpNextClient();
        }

        bool clientWasReady = false;

	    POSITION pos = uploadinglist.GetHeadPosition();
	    while (pos != NULL){
            // Get the client. Note! Also updates activeClientsListPos as a side effect.
		    CUpDownClient* cur_client = uploadinglist.GetNext(pos);
            bool tempWantsMoreBandwidth;

			// LANCAST (moosetea) - Just Count LAN Clients
			if (cur_client->isOnLAN())
				QtyLANClients++;
			else
				usedBandwidthThisCall += cur_client->SendBlockData(m_guessedMaxBandwidth-usedBandwidthThisCall, tempWantsMoreBandwidth);

            if(tempWantsMoreBandwidth == true) {
                clientWasReady = true;
            }
	    }

	    if (clientWasReady == false){
            if(m_guessedMaxBandwidth > 300) {
		        m_guessedMaxBandwidth -= 200;
            } else {
                m_guessedMaxBandwidth = 100;
            }
	    } else {
		    m_guessedMaxBandwidth += 200;
	    }

        m_MaxActiveClients = uploadinglist.GetCount();
    } else {
        // Normal case for limited upload.

        uint32 tempMaxActiveClients = 0;
        POSITION activeClientsListPos = activeClients_list.GetHeadPosition();
        while(activeClientsListPos != NULL) {
            uint32 activeClientsSnapshot = activeClients_list.GetAt(activeClientsListPos);

            if(activeClientsSnapshot > tempMaxActiveClients) {
                tempMaxActiveClients = activeClientsSnapshot;
            }

            activeClients_list.GetNext(activeClientsListPos);
        }
        m_MaxActiveClients = tempMaxActiveClients;

	    sint32 realMaxULRatems = (theApp.glob_prefs->GetMaxUpload()*1024*timeSinceLastGaveDataMs)/1000;

#define MINNUMBEROFTRICKLEUPLOADS 2

        // How many slots should be open? Trickle slots included (at least 2 trickles, 30% of total, and no slot is expected to use more than UPLOAD_CLIENT_DATARATE*2 in average, whichever number is largest)
        sint32 wantedNumberOfTotalUploads = max((uint32)(theApp.glob_prefs->GetMaxUpload()*1024/(UPLOAD_CLIENT_DATARATE*2)), m_MaxActiveClients + MINNUMBEROFTRICKLEUPLOADS);
        wantedNumberOfTotalUploads = max(wantedNumberOfTotalUploads, m_MaxActiveClients*1.3);

		POSITION lastpos = uploadinglist.GetTailPosition();

        CUpDownClient* lastClient = NULL;
        if(lastpos != NULL) {
            lastClient = uploadinglist.GetAt(lastpos);
        }

#define MINWAITBEFOREOPENANOTHERSLOTMS 1000

        // Add or remove connections as needed. Mostly, this is controlled by the number of
        // fully active uploads.

        if(AcceptNewClient(uploadinglist.GetCount()) && waitinglist.GetCount() > 0 &&
           wantedNumberOfTotalUploads > uploadinglist.GetCount() &&
           (lastClient == NULL || lastClient->GetUpStartTimeDelay() > MINWAITBEFOREOPENANOTHERSLOTMS)) {
            // There's not enough open uploads. Open more another one.
            AddUpNextClient();
        } else if(uploadinglist.GetCount() > MIN_UP_CLIENTS_ALLOWED &&
                AcceptNewClient(uploadinglist.GetCount()-1) == false) {
            // There's to many open uploads (propably due to the user changing
            // the upload limit to a lower value). Remove the last opened upload and put
            // it back on the waitinglist. When it is put back, it get
            // to keep its waiting time. This means it is likely to soon be
            // choosen for upload again.
            if(!lastClient->isOnLAN() && lastClient->GetUpStartTimeDelay() > 3*1000) {   
		        // Remove from upload list.
		        theApp.uploadqueue->RemoveFromUploadQueue(lastClient, ETS_TIMEOUT, true);

		        // add to queue again. This is almost the same as in method
		        //    theApp.uploadqueue->AddClientToQueue(lastClient,true);
		        waitinglist.AddTail(lastClient);
		        lastClient->SetUploadState(US_ONUPLOADQUEUE);
		        lastClient->SendRankingInfo();
		        theApp.emuledlg->transferwnd.m_wndQueueList.AddClient(lastClient, false);
		        theApp.emuledlg->transferwnd.UpdateUploadHeader();
            }
        }

        // There's some saved bandwidth that we want to try to spend this round.
        // curMaxULRatems keeps track of how much data we want to spend.
        sint32 curMaxULRatems = realMaxULRatems + leftoverBandwidth;

        sint32 allowedBandwidthThisCall = min(curMaxULRatems, realMaxULRatems+MAXFRAGSIZE);

        // Which active slot are we giving data each loop
        uint32 slotcounter = 0;

        bool wantsMoreBandWidth = false;

        POSITION ulpos = uploadinglist.GetHeadPosition();
        // The loop that gives the fully activated connections data.
        while (ulpos != NULL && /*slotcounter < activeClients &&*/ (allowedBandwidthThisCall > usedBandwidthThisCall) && wantsMoreBandWidth == false) {
            // Only allow this connection to take what has not already been taken
            // by the other connections above it in the list.
            uint32 allowedThisIteration = allowedBandwidthThisCall-usedBandwidthThisCall;

            // Get the client. Note! Also updates ulpos as a side effect.
		    CUpDownClient* cur_client = uploadinglist.GetNext(ulpos);

            // Give data to the upload, if it wants it. Remember how much data we have given this call.
            // The connection wont take any data if it hasn't emptied its buffer since we last gave it data.
            // variable wantsMoreBandWidth is updated by this method (it is a ref bool&)

			// LANCAST (moosetea) - Increment LanCount
			if (cur_client->isOnLAN())
				QtyLANClients++;
			else
				usedBandwidthThisCall += cur_client->SendBlockData(allowedThisIteration, wantsMoreBandWidth);

            slotcounter++;
	    }

#define MAXTIMESLOTISALLOWEDTOGOWITHOUTDATAMS 2540
        // Trickle the unneeded uploads (just give them enough to not time out)
        // Theese downloads are kept connected, in a ready-to-go state, just in case
        // one of the fully activated uploads completes/timeouts/ends.
        // As soon as there's a little bandwidth leftover, the first one of these
        // uploads will go to fully activated state
        POSITION trickle_client_pos = uploadinglist.FindIndex(slotcounter);
        while (trickle_client_pos != NULL){
            // Get the client. Note! Also updates trickle_client_pos as a side effect.
	        CUpDownClient* cur_client = uploadinglist.GetNext(trickle_client_pos);

            if(cur_client->GetLastGotULData() + MAXTIMESLOTISALLOWEDTOGOWITHOUTDATAMS < curTick) {
                // It's more than 3 seconds since this connection got any data.
                // Feed it a mercy package to prevent it from timing out.
                bool tempWantsMoreData = false;
				// LANCAST (moosetea) - Increment LanCount
				if (cur_client->isOnLAN())
					QtyLANClients++;
				else
					usedBandwidthThisCall += cur_client->SendBlockData(MAXFRAGSIZE, tempWantsMoreData);
            }
        }

        // Since we don't save bandwidth for the trickles above, we may
        // have used to much bandwidth.
        // We may also have used to little bandwidth this round, in that
        // case it is saved to the next round.
        leftoverBandwidth = curMaxULRatems-usedBandwidthThisCall;
        
        // We don't want to long peaks. Don't save to much bandwidth (about a second should be OK)
        // Always make sure we can save enough to get a packet through
        sint32 limitSave = MAXFRAGSIZE; // max(realMaxULRatems*10, MAXFRAGSIZE+realMaxULRatems*4);
        if(leftoverBandwidth > limitSave) {
            leftoverBandwidth = limitSave;
        }

        // Save number of active clients for statistics
   	    activeClients_list.RemoveHead();
	    activeClients_list.AddTail(slotcounter);
    }

    // Save sent bytes for speed calculations
	//Cax2 - refactored these lists: easier access to a subset of the data, and less memory usage!

	if(average_tick_list.empty() || curTick- average_tick_list.front()>=500)	//Cax2 - update no faster than every .5 sec
	{
		average_dr_list.push_front(theApp.stat_sessionSentBytes);
		average_tick_list.push_front(curTick);

		// remove anything older than 40  seconds
		while(curTick-average_tick_list.back() > 40000)
		{
   			average_dr_list.pop_back();
			average_tick_list.pop_back();
		}
	}
    // Save time to be able to calculate how long between each call
    m_lastGaveDataTick = curTick;

	// LANCAST (moosetea) - If we have more than one LAN user were going to upload to them
	// Were going to try uploading the way plus way....... 
	if (QtyLANClients > 0){

        bool clientWasReady = false;

	    POSITION pos = uploadinglist.GetHeadPosition();
	    while (pos != NULL){
            // Get the client. Note! Also updates activeClientsListPos as a side effect.
		    CUpDownClient* cur_client = uploadinglist.GetNext(pos);
            bool tempWantsMoreBandwidth = false;

			// LANCAST (moosetea) - Just Count LAN Clients
			if (cur_client->isOnLAN())
				cur_client->SendBlockData(m_guessedMaxLANBandwidth, tempWantsMoreBandwidth);

            if(tempWantsMoreBandwidth == true)
                clientWasReady = true;
      
	    }

	    if (clientWasReady == false){
            if(m_guessedMaxLANBandwidth > 3000) {
		        m_guessedMaxLANBandwidth -= 2000;
            } else {
               m_guessedMaxLANBandwidth = 1000;
            }
	    } else {
		    m_guessedMaxLANBandwidth += 2000;
	    }

	}

	// START enkeyDEV(th1) -L2HAC- lowid side, automatic callback phase
#ifdef OLD_SOCKETS_ENABLED
	if (theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID())
	{
		for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos))
		{
			CUpDownClient* cur_client = waitinglist.GetAt(pos);
			if (cur_client->IsL2HACEnabled()
				&& cur_client->GetLastL2HACExecution()
				&& cur_client->GetL2HACTime()
				&& (curTick - cur_client->GetLastL2HACExecution()) > cur_client->GetL2HACTime())
			{
				if (theApp.listensocket->TooManySockets() && !(cur_client->socket && cur_client->socket->IsConnected()) )
					cur_client->SetLastL2HACExecution(curTick - cur_client->GetL2HACTime() + (uint32)ROUND(((float)rand()/RAND_MAX)*300000));
				else
				{
					cur_client->DisableL2HAC();
					if (!cur_client->HasLowID() && cur_client->GetL2HACTime())
					cur_client->TryToConnect();
				}
			}
		}
	}
#endif //OLD_SOCKETS_ENABLED
	// END enkeyDEV(th1) -L2HAC-

	EMULE_CATCH
}
bool CUploadQueue::AcceptNewClient(uint32 numberOfUploads)
{
	EMULE_TRY

	// check if we can allow a new client to start downloading form us
	if (numberOfUploads < MIN_UP_CLIENTS_ALLOWED)
		return true;
	else if (numberOfUploads >= MAX_UP_CLIENTS_ALLOWED)
		return false;

	//now the final check
	if (theApp.glob_prefs->GetMaxUpload() == UNLIMITED){
		if (numberOfUploads < (GetDatarate()/UPLOAD_CLIENT_DATARATE))
			return true;
	} else {
		if (numberOfUploads < (uint32)(theApp.glob_prefs->GetMaxUpload()*1024/UPLOAD_LOW_CLIENT_DR)+1)
			return true;
	}
	//nope
	return false;

	EMULE_CATCH

	//nope
	return false;
}

CUploadQueue::~CUploadQueue(){
	KillTimer(0, h_timer);
	if ( m_hSaveSTimer )
	{
		m_pSaveThread->SuspendThread();
		__int64         qwDueTime;
		LARGE_INTEGER   liDueTime;
		qwDueTime = -1;         // Copy the relative time into a LARGE_INTEGER.
		liDueTime.LowPart  = (DWORD) ( qwDueTime & 0xFFFFFFFF );
		liDueTime.HighPart = (LONG)  ( qwDueTime >> 32 );
		// re-Set the timer to me inworked each second
		::SetWaitableTimer(m_hSaveSTimer,&liDueTime,1,NULL,NULL,TRUE);
		// Set the thread to Get more CPU to finish fast
		m_pSaveThread->SetThreadPriority(THREAD_PRIORITY_HIGHEST+ theApp.glob_prefs->GetMainProcessPriority());
		HANDLE hArr[2];
		hArr[0]	=	m_hSaveSTimer;
		hArr[1]	=	m_pSaveThread->m_hThread;
		// set thread to exit 
		m_bExiting	=	TRUE;
		// Resume the thread
		m_pSaveThread->ResumeThread();
		// Wait until thread finishes 10000 sec - this should be enough
		if ( WaitForMultipleObjects(2,hArr,TRUE,10000000) == WAIT_TIMEOUT )
		{
			TRACE("Thread known.met thread did not exited on time");
		}
	}
}

POSITION CUploadQueue::GetWaitingClient(CUpDownClient* client)
{
	EMULE_TRY

	return waitinglist.Find(client); 

	EMULE_CATCH

	return 0;
}

/*POSITION CUploadQueue::GetWaitingClientByID(CUpDownClient* client)
{
	EMULE_TRY

	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (client->Compare(waitinglist.GetAt(pos)))
			return pos;
	}

	EMULE_CATCH

	return 0;
}*/

CUpDownClient* CUploadQueue::GetWaitingClientByIP_UDP(uint32 dwIP, uint16 dwport)
{
	EMULE_TRY

	//v- eklmn: optimization: don't call waitinglist.GetNext(pos) many times
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;) {
		CUpDownClient* cur_client = waitinglist.GetNext(pos);
		if (dwIP == cur_client->GetIP())
			return cur_client;
        }

	EMULE_CATCH

	return 0;
}

/*
POSITION CUploadQueue::GetDownloadingClient(CUpDownClient* client)
{
	EMULE_TRY

	for (POSITION pos = uploadinglist.GetHeadPosition();pos != 0;uploadinglist.GetNext(pos)){
		if (client == uploadinglist.GetAt(pos))
			return pos;
	}

	EMULE_CATCH

	return 0;
}
*/
uint32	CUploadQueue::GetDatarateShown()		//Cax2 -  roughly 5 seconds sample rate: more immediate datarate feedback.
{
	if(average_dr_list.size() >9)		//Cax2 - do we have those '5 seconds'? (can be messed up by program freezes, etc)
	{
		list<uint64>::iterator dr=average_dr_list.begin();
		list<DWORD>::iterator tick=average_tick_list.begin();
		advance(dr,9);
		advance(tick,9);
		return (uint32)( (average_dr_list.front() - (*dr))*1000.0f/(average_tick_list.front() - (*tick)) );
	}
	else
		return GetDatarate();
}

uint32	CUploadQueue::GetDatarate()
{
    // Calculate average datarate
    if(GetTickCount()-m_lastCalculatedDataRateTick > 1000) {
        if(average_dr_list.size() >1) {
	        datarate = (uint32)(((float)(average_dr_list.front()-average_dr_list.back()))*1000 / (average_tick_list.front()-average_tick_list.back()));
        } else {
            datarate = 0;
        }
    }

    return datarate;
}


void CUploadQueue::UpdateBanCount()
{
	EMULE_TRY

	int count=0;
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if(cur_client->IsBanned())
			count++;
	}
	SetBanCount(count);

	EMULE_CATCH
}

void CUploadQueue::AddClientToQueue(CUpDownClient* client, bool bIgnoreTimelimit)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	if (theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID()
		&& !theApp.serverconnect->IsLocalServer(client->GetServerIP(),client->GetServerPort())
		&& client->GetDownloadState() == DS_NONE 
		&& !client->IsFriend()
		&& GetWaitingUserCount() > 50)
		return;
#endif //OLD_SOCKETS_ENABLED
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)client->reqfileid);
	// don't accept clients if requested file is in completing state
	if (reqfile && reqfile->IsPartFile() && ((CPartFile*)reqfile)->GetStatus() == PS_COMPLETING)
		return;

	//(filtering invalid eMule clients)
	if(client->GetMuleVersion()==0 && client->GetVersion()==0 && (client->GetClientSoft()==SO_EMULE || client->GetClientSoft()==SO_OLDEMULE)) {
		return;
	}
	//end (filtering invalid eMule clients) // Mr Faber / netwolf

	client->AddAskedCount();
	client->SetLastUpRequest();

	// START enkeyDEV(th1) -L2HAC- lowid side
	client->SetLastL2HACExecution();
	if (!client->HasLowID() && client->GetL2HACTime()) client->EnableL2HAC();
	// END enkeyDEV(th1) -L2HAC-

	// LANCAST (moosetea) - We ignore any ban LAN clients may have :)
	if (!bIgnoreTimelimit && !client->isOnLAN()){
		if (client->IsBanned()){
			if (GetTickCount() - client->GetBanTime() > theApp.glob_prefs->BadClientBanTime()){
				client->UnBan();
			}
			else
				return;
		}
		client->AddRequestCount(client->reqfileid);
	}
	// check for double
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if (cur_client == client){	//already on queue
			client->SendRankingInfo();
			theApp.emuledlg->transferwnd.m_wndQueueList.RefreshClient(client);
			return;			
		}
/* MERGE26
		// changing back, to avoid hack/mldonkey problems
		else if (client->GetIP() == cur_client->GetIP() || !memcmp(cur_client->GetUserHash(),client->GetUserHash(),16) ) {
		//else if ((client->GetIP() == cur_client->GetIP() && client->GetUserPort() == cur_client->GetUserPort())|| !memcmp(cur_client->GetUserHash(),client->GetUserHash(),16)){ // Lord KiRon
*/
		else if ( client->Compare(cur_client) ) {
			// another client with same ip or hash
			if (theApp.glob_prefs->IsSecureIdentEnabled())
			{
			
				if (client->credits->GetCurrentIdentState(client->GetIP()) == IS_IDENTIFIED && cur_client->credits->GetCurrentIdentState(cur_client->GetIP()) != IS_IDENTIFIED)
			
				{
					AddDebugLogLine(true,IDS_SAMEUSERHASH,client->GetUserName(),cur_client->GetUserName(),cur_client->GetUserName() );
					RemoveFromWaitingQueue(pos,true);
				} else
				if (client->credits->GetCurrentIdentState(client->GetIP()) != IS_IDENTIFIED && cur_client->credits->GetCurrentIdentState(cur_client->GetIP()) == IS_IDENTIFIED)
				{
					AddDebugLogLine(true,IDS_SAMEUSERHASH,client->GetUserName(),cur_client->GetUserName(),client->GetUserName() );		
					return;
				} else
				if (client->credits->GetCurrentIdentState(client->GetIP()) != IS_IDENTIFIED && cur_client->credits->GetCurrentIdentState(cur_client->GetIP()) != IS_IDENTIFIED)
				{
					AddDebugLogLine(true,IDS_SAMEUSERHASH,client->GetUserName(),cur_client->GetUserName(),'both' );
					RemoveFromWaitingQueue(pos,true);
					return;
				} else
			// EC - Can this happen? Maybe client tries to re-enter queue
				if (client->credits->GetCurrentIdentState(client->GetIP()) == IS_IDENTIFIED && cur_client->credits->GetCurrentIdentState(cur_client->GetIP()) == IS_IDENTIFIED)
				{
					AddDebugLogLine(true,"-->Two Identified clients (%s) and (%s)  have the same Userhash or IP, Removing %s",client->GetUserName(),cur_client->GetUserName(),cur_client->GetUserName());
					RemoveFromWaitingQueue(pos,true);	
				} 
			} else 
			{
			AddDebugLogLine(false,IDS_SAMEUSERHASH,client->GetUserName(),cur_client->GetUserName(),cur_client->GetUserName() );
			RemoveFromWaitingQueue(pos,true);	
			}
			
#ifdef OLD_SOCKETS_ENABLED
			if (!cur_client->socket)
				cur_client->Disconnected();	
#endif //OLD_SOCKETS_ENABLED
			return;
		}
	}
	// done

/*
	if(ASK_FOR_PARTS_ON_UPLOAD)
		client->SendFileRequestForUpload();
*/

	// Add clients server to list.
	if (theApp.glob_prefs->GetAddServersFromConn() && client->GetServerIP() && client->GetServerPort()){	//SyruS (0.29c)
		in_addr host;
		host.S_un.S_addr = client->GetServerIP();
		CString s(inet_ntoa(host));
		CServer* srv = new CServer(client->GetServerPort(), s);
		srv->SetListName(srv->GetAddress());
		if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(srv, true))
			delete srv;
		/*else
			AddLogLine(false,"Added new server: %s:%d", srv->GetFullIP(), srv->GetPort());*/
	}

	// statistic values
	//CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)client->reqfileid);
	if (reqfile) reqfile->statistic.AddRequest();
	
	// TODO find better ways to cap the list
	if ((uint32)waitinglist.GetCount() >= (theApp.glob_prefs->GetQueueSize()+bannedcount))
		return;
	if (client->IsDownloading()){
		// he's already downloading and wants probably only another file
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
#ifdef OLD_SOCKETS_ENABLED
		client->socket->SendPacket(packet,true);
#endif //OLD_SOCKETS_ENABLED
		client->SetLastGotULData();	//eklmn: set Upload Timer
		return;
	}
	//if (waitinglist.IsEmpty() && AcceptNewClient())
	//	AddUpNextClient(client);
	//else{

	// LANCAST (moosetea) - Lan users bypass the queue
	if (client->isOnLAN())
		AddUpNextClient(client);
	else{
		waitinglist.AddTail(client);
		client->SetUploadState(US_ONUPLOADQUEUE);
		client->SendRankingInfo();
		theApp.emuledlg->transferwnd.m_wndQueueList.AddClient(client);
		theApp.emuledlg->transferwnd.UpdateUploadHeader();
	}

	EMULE_CATCH
}

bool CUploadQueue::RemoveFromUploadQueue(CUpDownClient* client, eEndTransferSession eReason, bool updatewindow )
{
	if (!client) return false;
	
	EMULE_TRY

	POSITION removed_pos = 0;

	removed_pos = uploadinglist.Find(client);
	if (removed_pos)
	{
		uploadinglist.RemoveAt(removed_pos);
		
		if (updatewindow)
			theApp.emuledlg->transferwnd.m_wndUploadList.RemoveClient(client);

		//eklmn: Update a a stats
		//           if client got some byte s from us the session will succesfull, otherwise failed
		if (client->GetTransferedUp())
		{
			ULSession_Successfull++;
			if (client->GetTransferedUp() >= PARTSIZE)
				ULSession_Successfull_FullChunk++;
			else
				ULSession_Successfull_PartChunk[eReason]++;
		}
		else
		{
			ULSession_Failed[eReason]++;
		}
		
		// eklmn: if we transfer something we need to update a upload time
		if( client->GetTransferedUp()) totaluploadtime += client->GetUpStartTimeDelay()/1000;

		client->SetUploadState(US_NONE);
		client->ClearUploadBlockRequests();
		// Added by Tarod -saves known.met file to avoid loosing it by accident
		// theApp.knownfiles->Save(); // <- Origin of duplicated values in known.met?
		return true;

	}

	EMULE_CATCH
	return false;
}

uint32 CUploadQueue::GetAverageUpTime()
{
	if( ULSession_Successfull ){
		return totaluploadtime/ULSession_Successfull;
	}
	return 0;
}

bool CUploadQueue::RemoveFromWaitingQueue(CUpDownClient* client, bool updatewindow)
{
	EMULE_TRY

	POSITION pos = waitinglist.Find(client);
	if (pos){
		RemoveFromWaitingQueue(pos,updatewindow);
		if (updatewindow)
			theApp.emuledlg->transferwnd.UpdateUploadHeader(); // changed by FoRcHa
		return true;
	}

	EMULE_CATCH

	return false;
}

void CUploadQueue::RemoveFromWaitingQueue(POSITION pos, bool updatewindow)
{
	EMULE_TRY

	CUpDownClient* todelete = waitinglist.GetAt(pos);
	waitinglist.RemoveAt(pos);
	if(todelete == NULL)
		return;
	if( todelete->IsBanned() )
	{
#if KEEP_BANNED_CLIENTS
		//SyruS don't unban and remove from queue
		if (!theApp.glob_prefs->GetCMNotLog())
			AddDebugLogLine(false, _T("(NOT YET) Keeping banned client '%s' in waitingqueue"), todelete->GetUserName());
		//1st idea (dont use yet)... return;
#endif
		todelete->UnBan();
	}

	if (updatewindow)
		theApp.emuledlg->transferwnd.m_wndQueueList.RemoveClient(todelete);
	todelete->SetUploadState(US_NONE);

	EMULE_CATCH
}



bool CUploadQueue::CheckForTimeOver(CUpDownClient* client)
{
	EMULE_TRY

	uint32 score = client->GetScore(true,true); //Maella - Less CPU usage
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (score < waitinglist.GetAt(pos)->GetScore(true,false))
			return true;
	}

	EMULE_CATCH

	return false;
}


void CUploadQueue::DeleteAll()
{
	EMULE_TRY

	waitinglist.RemoveAll();
	uploadinglist.RemoveAll();

	EMULE_CATCH
}

uint16 CUploadQueue::GetWaitingPosition(CUpDownClient* client)
{
	EMULE_TRY

	if (!IsOnUploadQueue(client))
		return 0;
	uint16 rank = 1;
	uint32 myscore = client->GetScore(false);
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (waitinglist.GetAt(pos)->GetScore(false) > myscore)
			rank++;
	}
	return rank;

	EMULE_CATCH

	return 0;
}

void CUploadQueue::CompUpDatarateOverhead()
{
	EMULE_TRY

	m_AvarageUDRO_list.AddTail(m_nUpDataRateMSOverhead);
	if (m_AvarageUDRO_list.GetCount() > 150)
		m_AvarageUDRO_list.RemoveAt(m_AvarageUDRO_list.GetHeadPosition());
	m_nUpDatarateOverhead = 0;
	m_nUpDataRateMSOverhead = 0;
	for (POSITION pos = m_AvarageUDRO_list.GetHeadPosition();pos != 0;m_AvarageUDRO_list.GetNext(pos))
		m_nUpDatarateOverhead += m_AvarageUDRO_list.GetAt(pos);

	if(m_AvarageUDRO_list.GetCount() > 10)
		m_nUpDatarateOverhead = 10*m_nUpDatarateOverhead/m_AvarageUDRO_list.GetCount();
	else
		m_nUpDatarateOverhead = 0;

	EMULE_CATCH
}

VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime)
{
	EMULE_TRY

	// Barry - Don't do anything if the app is shutting down - can cause unhandled exceptions
	if (!theApp.emuledlg->IsRunning())
		return;

	theApp.clientlist->ResetAllValueCaches();
	theApp.uploadqueue->Process();
	theApp.downloadqueue->Process();

	//--- xrmb:statsautosave ---
	//--- it might be not the best idea to do this here :) ---
	//theApp.knownfiles->Process();		//Cax2 moved back to SaveSourcesThread() - this function is deprecated! :P
	//--- :xrmb ---
	
    theApp.uploadqueue->CompUpDatarateOverhead();
	theApp.downloadqueue->CompDownDatarateOverhead();
	counter++;

	// one second
	if (counter >= 10){
		counter=0;
	        theApp.clientcredits->Process();
		theApp.serverlist->Process();
		theApp.friendlist->Process();
#ifdef OLD_SOCKETS_ENABLED
		if( theApp.serverconnect->IsConnecting())
			theApp.serverconnect->TryAnotherConnectionrequest();
#endif //OLD_SOCKETS_ENABLED

		theApp.emuledlg->statisticswnd.UpdateConnectionsStatus();

#ifdef OLD_SOCKETS_ENABLED
		if (theApp.serverconnect->IsConnecting()) theApp.serverconnect->CheckForTimeout();
#endif //OLD_SOCKETS_ENABLED

		// -khaos--+++> Update connection stats...
		iupdateconnstats++;
		// 2 seconds
		if (iupdateconnstats>=2) {
			iupdateconnstats=0;
			theApp.emuledlg->statisticswnd.UpdateConnectionStats((float)theApp.uploadqueue->GetDatarate()/1024, (float)theApp.downloadqueue->GetDatarate()/1024);
		}
		// <-----khaos-

		// display graphs
		if(theApp.glob_prefs->GetTrafficOMeterInterval()>0) 
		{
			igraph++;

			if (igraph >= (uint32)(theApp.glob_prefs->GetTrafficOMeterInterval()) ) {
				igraph=0;
				theApp.emuledlg->statisticswnd.SetCurrentRate(((float)theApp.uploadqueue->GetDatarateShown())/1024,((float)theApp.downloadqueue->GetDatarate())/1024);
			}
		}
		if (theApp.emuledlg->activewnd == &theApp.emuledlg->statisticswnd && theApp.emuledlg->IsWindowVisible() )  {
			// display stats
			if (theApp.glob_prefs->GetStatsInterval()>0) {
				istats++;

				if (istats >= (uint32)(theApp.glob_prefs->GetStatsInterval()) ) {
					istats=0;
					theApp.emuledlg->ShowStatistics();
				}
			}
		}
		//save rates every second
		theApp.emuledlg->statisticswnd.RecordRate();
		// mobilemule sockets
#ifdef OLD_SOCKETS_ENABLED
#ifdef MOBILE_MULE
		theApp.mmserver->Process();
#endif //MOBILE_MULE
#endif //OLD_SOCKETS_ENABLED

		sec++;
		// 5 seconds
		if (sec>=5) {
			#ifdef _DEBUG
				if (!AfxCheckMemory()) AfxDebugBreak();
			#endif

			sec = 0;
		#ifdef OLD_SOCKETS_ENABLED
			theApp.listensocket->Process();
		#endif //OLD_SOCKETS_ENABLED
			theApp.OnlineSig(); // Added By Bouc7 
			theApp.emuledlg->ShowTransferRate();	// eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
			//TODO - Cax2 - need to refresh 'stuck' clients
			if (theApp.emuledlg->activewnd == &theApp.emuledlg->statisticswnd)
				theApp.emuledlg->ShowStatistics();
		}

		statsave++;
		if (statsave>=60) 
		{
			// Time to save our cumulative statistics.
			statsave=0;
			
			// -khaos--+++>
			// CPreferences::SaveStats() in Preferences.cpp
			// This function does NOT update the tree!
			theApp.glob_prefs->SaveStats();
			// <-----khaos-

			// obaldin/DonGato - Scheduler check
			if(theApp.glob_prefs->IsSCHEnabled())
			{
				CTime curr_t = CTime::GetCurrentTime();
				uint32 secs = curr_t.GetSecond() + 60*curr_t.GetMinute() + 60*60*curr_t.GetHour();

				if(secs > theApp.glob_prefs->GetSCHShift1()-120 && secs < theApp.glob_prefs->GetSCHShift1()+120)
				{
					// switching to shift1 speeds
					theApp.uploadqueue->SCHShift1UploadCheck();
					theApp.glob_prefs->SetMaxUpload(theApp.glob_prefs->GetSCHShift1Upload());
					theApp.glob_prefs->SetMaxDownload(theApp.glob_prefs->GetSCHShift1Download());
					theApp.glob_prefs->SetMaxConnections(theApp.glob_prefs->GetSCHShift1conn());
					theApp.glob_prefs->SetMaxDownloadConperFive(theApp.glob_prefs->GetSCHShift15sec());
					// Purity - Sending message for scheduler shift 1
					CString MessageText;
					MessageText.Format(CString("Switching to Shift 1"));
					theApp.smtpconnection->SendMail(MessageText, theApp.glob_prefs->GetUseSchedulerNotifier(), theApp.glob_prefs->IsSMTPInfoEnabled());
					theApp.emuledlg->ShowNotifier(MessageText, TBN_SCHEDULER, false, theApp.glob_prefs->GetUseSchedulerNotifier());
					CLoggable::AddDebugLogLine(true,CString("Switching to Shift 1"));
				} 
				else if (secs > theApp.glob_prefs->GetSCHShift2()-120 && secs < theApp.glob_prefs->GetSCHShift2()+120) 
				{
                    			int dayOfWeek = curr_t.GetDayOfWeek();
					if ((dayOfWeek==2 && theApp.glob_prefs->IsSCHExceptMon()) 
						|| (dayOfWeek==3 && theApp.glob_prefs->IsSCHExceptTue()) 
						|| (dayOfWeek==4 && theApp.glob_prefs->IsSCHExceptWed()) 
						|| (dayOfWeek==5 && theApp.glob_prefs->IsSCHExceptThu()) 
						|| (dayOfWeek==6 && theApp.glob_prefs->IsSCHExceptFri()) 
						|| (dayOfWeek==7 && theApp.glob_prefs->IsSCHExceptSat()) 
						|| (dayOfWeek==1 && theApp.glob_prefs->IsSCHExceptSun()))
                    			{
                        			CLoggable::AddDebugLogLine(true,CString("Day excepted!"));
					} 
					else 
					{
						// switching to shift2 speeds
						theApp.uploadqueue->SCHShift2UploadCheck();
						theApp.glob_prefs->SetMaxUpload(theApp.glob_prefs->GetSCHShift2Upload());
						theApp.glob_prefs->SetMaxDownload(theApp.glob_prefs->GetSCHShift2Download());
						theApp.glob_prefs->SetMaxConnections(theApp.glob_prefs->GetSCHShift2conn());
						theApp.glob_prefs->SetMaxDownloadConperFive(theApp.glob_prefs->GetSCHShift25sec());
						// Purity - Sending message for scheduler shift 2
						CString MessageText;
						MessageText.Format(CString("Switching to Shift 2"));
						theApp.smtpconnection->SendMail(MessageText, theApp.glob_prefs->GetUseSchedulerNotifier(), theApp.glob_prefs->IsSMTPInfoEnabled());
						theApp.emuledlg->ShowNotifier(MessageText, TBN_SCHEDULER, false, theApp.glob_prefs->GetUseSchedulerNotifier());
						CLoggable::AddDebugLogLine(true,CString("Switching to Shift 2"));
					}
				}
			}
		}
	}

	EMULE_CATCH
}

CUpDownClient* CUploadQueue::GetNextClient(CUpDownClient* lastclient)
{
	EMULE_TRY

	if (waitinglist.IsEmpty())
		return NULL;
	if (!lastclient)
		return waitinglist.GetHead();
	POSITION pos = waitinglist.Find(lastclient);
	if (!pos){
		TRACE("Error: CServerList::GetNextClient");
		return waitinglist.GetHead();
	}
	waitinglist.GetNext(pos);
	if (!pos)
		return NULL;
	else
		return waitinglist.GetAt(pos);

	EMULE_CATCH

	return NULL;
}

void CUploadQueue::FindSourcesForFileById(CTypedPtrList<CPtrList, CUpDownClient*>* srclist, const uchar* filehash) 
{
	EMULE_TRY

	POSITION pos;
	
	pos = uploadinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = uploadinglist.GetNext(pos);
		if(md4cmp(potential->reqfileid, filehash) == 0)
			srclist->AddTail(potential);
	}

	pos = waitinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = waitinglist.GetNext(pos);
		if(md4cmp(potential->reqfileid, filehash) == 0)
			srclist->AddTail(potential);
	}

	EMULE_CATCH
}


UINT SaveSourcesThread(HANDLE lpArg)
{
	HANDLE hTimer;
	hTimer	=	((CUploadQueue*)lpArg)->m_hSaveSTimer;
	if ( !hTimer )
	{
		return -1;
	}
    __int64         qwDueTime;
     LARGE_INTEGER   liDueTime;
    qwDueTime = -30*60*1000;         // Copy the relative time into a LARGE_INTEGER.
    liDueTime.LowPart  = (DWORD) ( qwDueTime & 0xFFFFFFFF );
    liDueTime.HighPart = (LONG)  ( qwDueTime >> 32 );
	// Set timer to signal each 30 min 
	::SetWaitableTimer(hTimer,&liDueTime,30*60*1000,NULL,NULL,TRUE);
	bool bFirstRun	=	true;
	while (!(((CUploadQueue*)lpArg)->m_bExiting) )
	{
		// Wait for timer signal 
		::WaitForSingleObject(hTimer,INFINITE);
		// If eMule supposed to exit
		if ( (((CUploadQueue*)lpArg)->m_bExiting) )
		{
			// break and finish the thread
			break;
		}
		// avoid running right away
		if ( bFirstRun )
		{
			bFirstRun	=	false;
			continue;
		}
		SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL+ theApp.glob_prefs->GetMainProcessPriority());
		// process (save) sources each 30 min
		//theApp.knownfiles->Process();			//Cax2 - no more need for that..
		theApp.knownfiles->Save();	
		SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL+ theApp.glob_prefs->GetMainProcessPriority());
	}
	// Close timer also to signal that we finished
	::CloseHandle(hTimer);
	return 0;
}

void CUploadQueue::SCHShift1UploadCheck()
{
	EMULE_TRY

	if(theApp.glob_prefs->GetSCHShift1Upload() != 0)
	{
		if(theApp.glob_prefs->GetSCHShift1Upload() < 4 && (theApp.glob_prefs->GetSCHShift1Upload()*3 < theApp.glob_prefs->GetSCHShift1Download()))
			theApp.glob_prefs->SetSCHShift1Download(theApp.glob_prefs->GetSCHShift1Upload()*3);

		if(theApp.glob_prefs->GetSCHShift1Upload() < 10 && (theApp.glob_prefs->GetSCHShift1Upload()*4 < theApp.glob_prefs->GetSCHShift1Download()))
			theApp.glob_prefs->SetSCHShift1Download(theApp.glob_prefs->GetSCHShift1Upload()*4);
	}

	EMULE_CATCH
}

void CUploadQueue::SCHShift2UploadCheck()
{
	EMULE_TRY

	if(theApp.glob_prefs->GetSCHShift2Upload() != 0)
	{
		if(theApp.glob_prefs->GetSCHShift2Upload() < 4 && (theApp.glob_prefs->GetSCHShift2Upload()*3 < theApp.glob_prefs->GetSCHShift2Download()))
			theApp.glob_prefs->SetSCHShift2Download(theApp.glob_prefs->GetSCHShift2Upload()*3);

		if(theApp.glob_prefs->GetSCHShift2Upload() < 10 && (theApp.glob_prefs->GetSCHShift2Upload()*4 < theApp.glob_prefs->GetSCHShift2Download()))
			theApp.glob_prefs->SetSCHShift2Download(theApp.glob_prefs->GetSCHShift2Upload()*4);
	}

	EMULE_CATCH
}

bool CUploadQueue::IsFileUploading (CPartFile* check_file)
{
	EMULE_TRY

	CUpDownClient* cur_client;
	for(POSITION pos = uploadinglist.GetHeadPosition(); pos != NULL; uploadinglist.GetNext(pos))
	{
		cur_client = uploadinglist.GetAt(pos);
		if (cur_client->reqfile == check_file)
			return true;
	}
		
	return false;
	EMULE_CATCH
	return true;
}
