//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// emuleDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "afxinet.h"
#include "emule.h"
#include "emuleDlg.h"
#ifdef OLD_SOCKETS_ENABLED
#include "sockets.h"
#endif //OLD_SOCKETS_ENABLED
#include "knownfilelist.h"
#include "knownfile.h"
#include "serverlist.h"
#include "opcodes.h"
#include "sharedfilelist.h"
#include "ED2KLink.h"
#include "math.h"
#include "Splashscreen.h"
#pragma comment(lib, "winmm.lib")
#include "Mmsystem.h"
#include "enbitmap.h"

#include "EngineData.h"
#include "Sockets/EmEngine.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//Lucas - 08-Jan Define settig the Timer ID to be used. 
//Could be interesting to standarize the TIMER_IDs (there are many already) 
#define INIT_TIMER_ID 1234 // This is a magic number...  

const static UINT UWM_ARE_YOU_EMULE=RegisterWindowMessage(_T(EMULE_GUID));
// CemuleDlg Dialog

CemuleDlg::CemuleDlg(CWnd* pParent /*=NULL*/)
	: CTrayDialog(CemuleDlg::IDD, pParent)
{
	EMULE_TRY

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	mytrayIcon	=	NULL;
	ready = false;
	startUpMinimized=false;
	lastuprate = 0;
	lastdownrate = 0;
	theApp.m_app_state = theApp.APP_STATE_RUNNING;
	status = 0;
	connicons[0] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_NOTCONNECTED),IMAGE_ICON,16,16,0);
	connicons[1] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_CONNECTED),IMAGE_ICON,16,16,0);
	connicons[2] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_CONNECTEDHIGH),IMAGE_ICON,16,16,0);
	transicons[0] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UP0),IMAGE_ICON,16,16,0);
	transicons[1] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UP1),IMAGE_ICON,16,16,0);
	transicons[2] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_DOWN0),IMAGE_ICON,16,16,0);
	transicons[3] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_DOWN1),IMAGE_ICON,16,16,0);
	imicons[0] = 0;
	imicons[1] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_MESSAGE),IMAGE_ICON,16,16,0);
	imicons[2] = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_MPENDING),IMAGE_ICON,16,16,0);
	sourceTrayIcon = (HICON)LoadImage(AfxGetInstanceHandle() ,MAKEINTRESOURCE(IDI_TRAYICON),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	sourceTrayIconLowID = (HICON)LoadImage(AfxGetInstanceHandle() ,MAKEINTRESOURCE(IDI_TRAYICON_LOWID),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	sourceTrayIconGrey = (HICON)LoadImage(AfxGetInstanceHandle() ,MAKEINTRESOURCE(IDI_TRAYICON_GREY),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	usersicon = (HICON)::LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_USERS),IMAGE_ICON,16,16,0);
	m_pSystrayDlg = NULL;

#ifdef NEW_SOCKETS
	m_pEngineData = new CEngineData(*theApp.pEngine);
#endif //NEW_SOCKETS

	EMULE_CATCH2
}

CemuleDlg::~CemuleDlg()
{
	EMULE_TRY
	if (mytrayIcon) DestroyIcon(mytrayIcon);
	::DestroyIcon(m_hIcon);
	::DestroyIcon(connicons[0]);
	::DestroyIcon(connicons[1]);
	::DestroyIcon(connicons[2]);
	::DestroyIcon(transicons[0]);
	::DestroyIcon(transicons[1]);
	::DestroyIcon(transicons[2]);
	::DestroyIcon(transicons[3]);
	::DestroyIcon(imicons[1]);
	::DestroyIcon(imicons[2]);
	::DestroyIcon(sourceTrayIcon);
	::DestroyIcon(sourceTrayIconLowID);
	::DestroyIcon(sourceTrayIconGrey);
	::DestroyIcon(usersicon);
	if ( mytrayIcon )
	{
		DestroyIcon(mytrayIcon);
	}
	serverwnd.DestroyWindow();
	sharedfileswnd.DestroyWindow();
	searchwnd.DestroyWindow();
	chatwnd.DestroyWindow();
	transferwnd.DestroyWindow();
	statisticswnd.DestroyWindow();
	ircwnd.DestroyWindow();

#ifdef NEW_SOCKETS
	if(m_pEngineData)
		delete m_pEngineData;
#endif //NEW_SOCKETS

	EMULE_CATCH2
}

void CemuleDlg::DoDataExchange(CDataExchange* pDX){
	CTrayDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CemuleDlg, CTrayDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_CLOSE()

	ON_COMMAND(MP_CONNECT, StartConnection)
	ON_COMMAND(MP_DISCONNECT, CloseConnection)
	ON_COMMAND(MP_EXIT, OnClose )

	ON_MESSAGE(WM_TASKBARNOTIFIERCLICKED, OnTaskbarNotifierClicked)
	ON_MESSAGE(WM_COPYDATA, OnWMData)
	ON_MESSAGE(TM_FINISHEDHASHING,OnFileHashed)
	ON_COMMAND(MP_RESTORE, RestoreWindow)
/*
	// quick-speed changer --
	ON_COMMAND_RANGE(MP_QS_U10, MP_QS_UP10, QuickSpeedUpload)
	ON_COMMAND_RANGE(MP_QS_D10, MP_QS_DC, QuickSpeedDownload)
	//--- quickspeed - paralize all ---
	ON_COMMAND_RANGE(MP_QS_PA, MP_QS_UA, QuickSpeedOther)
	// quick-speed changer -- based on xrmb
*/
	ON_REGISTERED_MESSAGE(UWM_ARE_YOU_EMULE, OnAreYouEmule)

	//kuchin
	ON_MESSAGE(WEB_CONNECT_TO_SERVER, OnWebServerConnect)
	ON_MESSAGE(WEB_REMOVE_SERVER, OnWebServerRemove)
    //purity
	ON_MESSAGE(WEB_ADD_TO_STATIC, OnWebServerAddToStatic)
	ON_MESSAGE(WEB_REMOVE_FROM_STATIC, OnWebServerRemoveFromStatic)

	ON_MESSAGE(WEB_SHARED_FILES_RELOAD, OnWebSharedFilesReload)

	ON_MESSAGE(WM_TASK_UI, OnProcessTaskUI)

	ON_WM_QUERYENDSESSION()
	ON_WM_TIMER() // Lucas
	ON_WM_NCDESTROY()
END_MESSAGE_MAP()

// CemuleDlg eventhandler

LRESULT CemuleDlg::OnAreYouEmule(WPARAM, LPARAM)
{
  return UWM_ARE_YOU_EMULE;
} 

BOOL CemuleDlg::OnInitDialog()
{	
	EMULE_TRY

	CTrayDialog::OnInitDialog();
	
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL){
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, GetResString(IDS_ABOUTBOX));
	}

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);

	//set font - Cax2
	m_DefaultFont.CreatePointFont(theApp.glob_prefs->GetFontSize(),theApp.glob_prefs->GetUsedFont()); // DonGato

	//set toolbar
	toolbar.Create(WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, CRect(0,0,0,0), this, IDC_TOOLBAR);
	toolbar.Init();
	toolbar.ShowSpeedMeter(theApp.glob_prefs->GetShowToolbarSpeedMeter());
	int iMaxRange = theApp.glob_prefs->GetMaxGraphDownloadRate();
	if(theApp.glob_prefs->GetMaxGraphUploadRate() > iMaxRange)
		iMaxRange = theApp.glob_prefs->GetMaxGraphUploadRate();
	toolbar.SetSpeedMeterRange(iMaxRange, 0);

#ifdef USE_REBAR
	//set rebar
	REBARBANDINFO rbbi;
	CSize sizeBar;
	toolbar.GetMaxSize(&sizeBar);
	rebar.Create(WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_BORDER | RBS_BANDBORDERS | /*RBS_AUTOSIZE |*/ RBS_VARHEIGHT | CCS_NODIVIDER | CCS_TOP,
                CRect(0, 0, 0, 0),
				this,
				AFX_IDW_REBAR);

	// insert tool bar
	rbbi.cbSize       = sizeof(REBARBANDINFO);
	rbbi.fMask        = RBBIM_SIZE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE;
	rbbi.cxMinChild   = 0;
	rbbi.cyMinChild   = sizeBar.cy;
	rbbi.cx           = 0;
	rbbi.fStyle       = RBBS_NOGRIPPER | RBBS_BREAK;
	rbbi.hwndChild    = (HWND) toolbar;
	rebar.InsertBand(-1, &rbbi);

	// insert address bar
	/*
	CComboBoxEx *combo = new CComboBoxEx();
	CRect rcAddress;
	combo->Create(WS_CHILD | WS_CLIPCHILDREN | WS_TABSTOP | CCS_NODIVIDER | CBS_DROPDOWN, CRect(0, 0, 0, 200), this, AFX_IDW_TOOLBAR + 1);
	combo->GetWindowRect(&rcAddress);
	rbbi.cbSize       = sizeof(REBARBANDINFO);
	rbbi.fMask        = RBBIM_SIZE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_TEXT;
	rbbi.cxMinChild   = 0;
	rbbi.cyMinChild   = rcAddress.Height();
	rbbi.cx           = 0;
	rbbi.fStyle       = RBBS_NOGRIPPER | RBBS_BREAK;
	rbbi.hwndChild    = combo->GetSafeHwnd();
	rbbi.lpText       = _T("Address");
	rebar.InsertBand(-1, &rbbi);
	 */
#endif

	//set title
	CString buffer;
	buffer.Format(_T("eMule Plus v%s"),CURRENT_VERSION_LONG);
	SetWindowText(buffer);

	//START - enkeyDEV(kei-kun) -TaskbarNotifier-
	m_wndTaskbarNotifier.Create(this);
	CEnBitmap m_imgTaskbar;
	VERIFY(m_imgTaskbar.LoadImage(IDR_POPUP,_T("JPG")));
	m_wndTaskbarNotifier.SetBitmap(&m_imgTaskbar, 255, 0, 255);
	m_wndTaskbarNotifier.SetTextFont(_T("Arial"),theApp.glob_prefs->NotificationFontSize(),TN_TEXT_NORMAL,TN_TEXT_UNDERLINE);
	m_wndTaskbarNotifier.SetTextColor(RGB(255,255,230),RGB(255,255,255));
	m_wndTaskbarNotifier.SetTextRect(CRect(14,40,m_wndTaskbarNotifier.m_nBitmapWidth-14,m_wndTaskbarNotifier.m_nBitmapHeight-14));
	
	// set statusbar
	statusbar.Create(WS_CHILD|WS_VISIBLE|CCS_BOTTOM|SBARS_SIZEGRIP|SBT_TOOLTIPS,CRect(0,0,0,0), this, IDC_STATUSBAR) ;	//Cax2 status bar tooltip
	statusbar.EnableToolTips(true);
	ResizeStatusBar();
	statusbar.SetIcon(2, usersicon);

	// create dialog pages
	preferenceswnd.SetPrefs(theApp.glob_prefs);
	serverwnd.Create(IDD_SERVER);
	sharedfileswnd.Create(IDD_FILES);
	searchwnd.Create(IDD_SEARCH);
	chatwnd.Create(IDD_CHAT);
	transferwnd.Create(IDD_TRANSFER);
	statisticswnd.Create(IDD_STATISTICS);
	ircwnd.Create(IDD_IRC);
	activewnd = &transferwnd;

	CRect rClientRect;
	GetClientRect(&rClientRect);
#ifdef USE_REBAR
	CRect rReBarRect;
	rebar.GetWindowRect(&rReBarRect);
	CRect rStatusbarRect;
	statusbar.GetWindowRect(&rStatusbarRect);
	rClientRect.top += rReBarRect.Height();
	rClientRect.bottom -= rStatusbarRect.Height();
#else
	CRect rToolbarRect;
	toolbar.GetWindowRect(&rToolbarRect);
	CRect rStatusbarRect;
	statusbar.GetWindowRect(&rStatusbarRect);
	rClientRect.top += rToolbarRect.Height();
	rClientRect.bottom -= rStatusbarRect.Height();
#endif
	serverwnd.SetWindowPos(NULL, rClientRect.left, rClientRect.top, 
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	transferwnd.SetWindowPos(NULL, rClientRect.left, rClientRect.top, 
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	sharedfileswnd.SetWindowPos(NULL, rClientRect.left, rClientRect.top, 
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	searchwnd.SetWindowPos(NULL, rClientRect.left, rClientRect.top, 
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	chatwnd.SetWindowPos(NULL, rClientRect.left, rClientRect.top, 
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	ircwnd.SetWindowPos(NULL, rClientRect.left, rClientRect.top,
							rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
	statisticswnd.SetWindowPos(NULL, rClientRect.left, rClientRect.top, 
								rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);

	// set updateintervall of graphic rate display (in seconds)
	ShowConnectionState(false);

	// anchors
	AddAnchor(serverwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(transferwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(sharedfileswnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(searchwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(chatwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(ircwnd,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(statusbar,BOTTOM_LEFT,BOTTOM_RIGHT);
	AddAnchor(statisticswnd,TOP_LEFT,BOTTOM_RIGHT);
#ifdef USE_REBAR
	AddAnchor(rebar,TOP_LEFT, TOP_RIGHT);
#else
	AddAnchor(toolbar,TOP_LEFT, TOP_RIGHT);
#endif

	statisticswnd.ShowInterval();
	// tray icon
	TraySetMinimizeToTray(theApp.glob_prefs->DoMinToTray());
	TrayMinimizeToTrayChanged(); // #zegzav (add)

	// Update Categories
	searchwnd.UpdateCatTabs();

	serverwnd.ShowWindow(SW_SHOW);
	activewnd = &serverwnd;

	if (theApp.pendinglink){
		OnWMData(NULL,(LPARAM) &theApp.sendstruct); // changed by Cax2 28/10/02
		delete theApp.pendinglink;
	}

	theApp.glob_prefs->SetSmartIdState(1);		//Cax2 - smartId bugfix
	
/*	// kuchin - if somebody knows the meaning of this code here,
	// tell me please. cause i don't.
	//Cax2 - the test is meant for win9x (it also returns true for win NT and was to stop emule from autoconnecting too soon
	if(!(LOBYTE(theApp.glob_prefs->GetWindowsVersion()) == 0x04))
	{
		if (theApp.glob_prefs->DoAutoConnect())
			DisConnect();
	}
*/
	// Restore saved window placement
	WINDOWPLACEMENT wp;wp.length=sizeof(wp);
	wp=theApp.glob_prefs->GetEmuleWindowPlacement();
	SetWindowPlacement(&wp);

	Localize();
	// the ShowTransferRate(true); is called in localite

#ifdef OLD_SOCKETS_ENABLED
#ifdef MOBILE_MULE
	theApp.mmserver->Init();
#endif //MOBILE_MULE
#endif //OLD_SOCKETS_ENABLED

	// splashscreen
	if (theApp.glob_prefs->UseSplashScreen() && !theApp.glob_prefs->GetStartMinimized())
	{
		CSplashScreen splash(this);
		splash.DoModal();
	}

	if (!SetTimer(INIT_TIMER_ID,300,NULL))
		AfxMessageBox(GetResString(IDS_ERR_FAILEDTIMER));

#ifdef NEW_SOCKETS
	theApp.pEngine->Init(m_hWnd);
#endif //NEW_SOCKETS

	return TRUE;

	EMULE_CATCH2

	return FALSE;
}

void CemuleDlg::OnTimer(UINT_PTR nIDEvent)
{
	EMULE_TRY
	
	if (nIDEvent == INIT_TIMER_ID) // #zegzav (added)
	{
		KillTimer(nIDEvent);
		switch (status)
		{
			case 0:
				status++;
				ready = true;
				theApp.sharedfiles->SetOutputCtrl(&sharedfileswnd.sharedfilesctrl);
				break;
				
			case 1:
				status++;
				theApp.serverlist->Init();
				break;
			case 2:
				status++;
				theApp.downloadqueue->Init();
#ifdef OLD_SOCKETS_ENABLED
				if (!theApp.listensocket->StartListening())
					AddLogLine(false,IDS_MAIN_SOCKETERROR,theApp.glob_prefs->GetPort());
				if (!theApp.clientudp->Create())
			   		AddLogLine(false,IDS_MAIN_SOCKETERROR,theApp.glob_prefs->GetUDPPort());
#endif //OLD_SOCKETS_ENABLED
				AddLogLine(true,IDS_MAIN_READY,CURRENT_VERSION_LONG);
				if (theApp.glob_prefs->DoAutoConnect())
					OnBnClickedButton2();
			
				// kuchin
				// Start server anyway, but you'll get response
				// only if it's enabled in preferences
				theApp.webserver->StartServer();
				break;
			default:
				AddDebugLogLine(true,_T("Timer called with no reason"));
		}
	}
	CTrayDialog::OnTimer(nIDEvent);
	
	if (nIDEvent == INIT_TIMER_ID) 
	{ 
	    if (status < 3) 
	        if (!SetTimer(INIT_TIMER_ID,300,NULL)) 
	            AfxMessageBox(GetResString(IDS_ERR_FAILEDTIMER)); 
	}
	
	EMULE_CATCH2
}


void CemuleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	EMULE_TRY

	CAboutDlg dlgAbout;
	switch(nID & 0xFFF0) 
	{
		case IDM_ABOUTBOX:
			dlgAbout.DoModal();		
			break;
		case SC_CLOSE:
		        if(theApp.glob_prefs->GetCloseToTray()) 
			{
				TrayShow();
				ShowWindow(SW_HIDE);
			}
			else
				CTrayDialog::OnSysCommand(nID, lParam);
			break;
		//v- eklmn: bugfix(12): improved output in statusbar (update only tray or window)
		case SC_MINIMIZE:
		case SC_MINIMIZETRAY:
		case SC_RESTORE:
		case SC_MAXIMIZE:
			CTrayDialog::OnSysCommand(nID, lParam);
			ShowTransferRate(true);
			break;
		//^- eklmn: bugfix(12): improved output in statusbar (update only tray or window)
		default:
			CTrayDialog::OnSysCommand(nID, lParam);
	}

	EMULE_CATCH2
}

void CemuleDlg::OnPaint() 
{
	EMULE_TRY

	if (!startUpMinimized) {
		startUpMinimized=true;
		if (theApp.glob_prefs->GetStartMinimized())
			OnCancel();
	}

	if (IsIconic()){
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else{
		CTrayDialog::OnPaint();
	}

	EMULE_CATCH2
}


HCURSOR CemuleDlg::OnQueryDragIcon(){
	return static_cast<HCURSOR>(m_hIcon);
}

void CemuleDlg::OnBnClickedButton2()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
    if (!theApp.serverconnect->IsConnected()) 
      //connect if not currently connected
	  if (!theApp.serverconnect->IsConnecting()  ) StartConnection(); else {
		  theApp.serverconnect->StopConnectionTry();
		  ShowConnectionState(false);
	  }
    else
      //disconnect if currently connected
      CloseConnection();
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}

void CemuleDlg::ResetLog()
{
	EMULE_TRY

	CSingleLock singleLock(&critical_log_section);	//Cax2 - this needs the mutex too
	singleLock.Lock();
	logtext="";
	serverwnd.logbox.SetWindowText(logtext);
	singleLock.Unlock();

	EMULE_CATCH2
}

void CemuleDlg::ResetDebugLog()
{
	EMULE_TRY

	CSingleLock singleLock(&critical_log_section);	//Cax2 - this needs the mutex too
	singleLock.Lock();
	debuglog="";
	serverwnd.debugbox.SetWindowText(debuglog);
	singleLock.Unlock();

	EMULE_CATCH
}

void CemuleDlg::AddLogText(bool addtostatusbar,const CString& txt, bool bDebug) {
	EMULE_TRY

	if (addtostatusbar)
        if (statusbar.m_hWnd && theApp.m_app_state != CemuleApp::APP_STATE_SHUTINGDOWN)
		{
			statusbar.SetText(txt,0,0);
			statusbar.SetTipText(0,txt);
		}
		else
			AfxMessageBox(txt);

	char temp[1060]; //<<--9/21/02
	COleDateTime timelog(COleDateTime::GetCurrentTime()); // DonGato date-time localization
	sprintf(temp,"%s: %s",timelog.Format(),txt); // DonGato date-time localization

	CSingleLock singleLock(&critical_log_section);
	CEdit2 *logbox=(bDebug)?&serverwnd.debugbox:&serverwnd.logbox;

	singleLock.Lock();   //critical section!

	CString boxtext=(bDebug)?debuglog:logtext;
    //ASSERT(singleLock.IsLocked()); 
	if (logbox->GetSafeHwnd() && logbox->GetLineCount() >= MAX_LINES_IN_LOGVIEW)	//Cax2 - putting it here should avoid repeated lines
	{
		int pos = boxtext.Find('\r'); 
		if (pos >= 0)  
			boxtext=boxtext.Mid(pos + 2);	// skip '\n'
	}
	boxtext+= (CString)temp + _T("\r\n");

	if (bDebug)
		debuglog=boxtext;
	else
		logtext=boxtext;

	singleLock.Unlock();

	if (logbox->GetSafeHwnd())
	{
		logbox->SetWindowText(boxtext); // this call cannot be placed inside the critical section! (message pump) 
		logbox->LineScroll(logbox->GetLineCount());
		ShowNotifier(txt, TBN_LOG, false, theApp.glob_prefs->GetUseLogNotifier());
	}

	if (theApp.glob_prefs->LogToFile())
	{
		CString LogFilePath = theApp.glob_prefs->GetAppDir();
		if(bDebug)
			LogFilePath += CString(_T("debug.log"));
		else
			LogFilePath += CString(_T("emule.log"));			
		FILE* LogFile = _tfopen(LogFilePath, _T("a+")); 
		if ( LogFile != NULL )
	 	{
			strcat(temp, "\n");
 			fwrite(temp, sizeof(char), strlen(temp), LogFile);
 			fclose(LogFile);
	 	}
	}

	EMULE_CATCH2
}

void CemuleDlg::AddServerMessageLine(LPCTSTR line)
{
	EMULE_TRY
	serverwnd.servermsgbox.AppendText(line+CString(_T('\n'))); //merge from offic. 0.30a - bond006
	EMULE_CATCH2
}

void CemuleDlg::AddBugReport(LPCTSTR sFile, long nLine, CString msg)
{
	EMULE_TRY

	if(theApp.glob_prefs->GetBugReport())
	{
		CString sOut;
		sOut.Format(_T("EXCEPTION! (%s) Report to eMule Plus developers. Line %ld in file "), msg, nLine);
		sOut += CString(sFile);
		AddDebugLogLine(false, sOut);
	}

	EMULE_CATCH2
}

void CemuleDlg::ShowConnectionState()
{
#ifdef OLD_SOCKETS_ENABLED
	ShowConnectionState( theApp.serverconnect->IsConnected() ,_T(""));
#endif //OLD_SOCKETS_ENABLED
}

void CemuleDlg::ShowConnectionState(bool connected)
{
	ShowConnectionState(connected,_T(""));
}

void CemuleDlg::ShowConnectionState(bool connected, CString server,bool iconOnly)
{
	EMULE_TRY

	if (connected)
	{
		TCHAR szBuf[200];
		_stprintf(szBuf, _T("%s"), GetResString(IDS_MAIN_BTN_DISCONNECT));
		LPTSTR pszBuf;
		TBBUTTONINFO tbi;
		LPTBBUTTONINFO lptbbi;
		pszBuf = szBuf;
		lptbbi = &tbi;
		tbi.dwMask = TBIF_IMAGE | TBIF_TEXT;
		tbi.cbSize = sizeof (TBBUTTONINFO);
		tbi.iImage = 9;
		tbi.pszText = pszBuf;
		tbi.cchText = sizeof (szBuf);
		toolbar.SetButtonInfo(IDC_TOOLBARBUTTON+0, lptbbi);
		//TOOLTIP: GetResString(IDS_MAIN_BTN_DISCONNECT_TOOLTIP)
		toolbar.AutoSize();
				
#ifdef OLD_SOCKETS_ENABLED
		if (theApp.serverconnect->IsLowID()) 
#endif //OLD_SOCKETS_ENABLED
#ifdef NEW_SOCKETS
		if(m_pEngineData->IsLowID())
#endif //NEW_SOCKETS
			statusbar.SetIcon(5,connicons[1]);
		 else 
			statusbar.SetIcon(5,connicons[2]);
		
		if (!iconOnly) {
			statusbar.SetText(GetResString(IDS_MAIN_CONNECTEDTO) + CString(server),0,0);
			statusbar.SetTipText(0,statusbar.GetText(0));
			statusbar.SetTipText(5,server);
			statusbar.SetText(server,5,0);
		}
	}
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		if (theApp.serverconnect->IsConnecting()) 
#endif //OLD_SOCKETS_ENABLED
#ifdef NEW_SOCKETS
		if(m_pEngineData->IsConnecting())
#endif //NEW_SOCKETS
		{
			TCHAR szBuf[200];
			_stprintf(szBuf, _T("%s"), GetResString(IDS_MAIN_BTN_CANCEL));
			LPTSTR pszBuf;
			TBBUTTONINFO tbi;
			LPTBBUTTONINFO lptbbi;
			pszBuf = szBuf;
			lptbbi = &tbi;
			tbi.dwMask = TBIF_IMAGE | TBIF_TEXT;
			tbi.cbSize = sizeof (TBBUTTONINFO);
			tbi.iImage = 10;
			tbi.pszText = pszBuf;
			tbi.cchText = sizeof (szBuf);
			toolbar.SetButtonInfo(IDC_TOOLBARBUTTON+0, lptbbi);
			//TOOLTIP: GetResString(IDS_MAIN_BTN_CONNECT_TOOLTIP)
			
			statusbar.SetIcon(5,connicons[0]);
			if (!iconOnly) {
				statusbar.SetText(GetResString(IDS_CONNECTING),5,0);
				statusbar.SetTipText(5,_T(""));
			}
			ShowUserCount(0,0);

		} 
		else 
		{
			TCHAR szBuf[200];
			_stprintf(szBuf, _T("%s"), GetResString(IDS_MAIN_BTN_CONNECT));
			LPTSTR pszBuf;
			TBBUTTONINFO tbi;
			LPTBBUTTONINFO lptbbi;
			pszBuf = szBuf;
			lptbbi = &tbi;
			tbi.dwMask = TBIF_IMAGE | TBIF_TEXT;
			tbi.cbSize = sizeof (TBBUTTONINFO);
			tbi.iImage = 0;
			tbi.pszText = pszBuf;
			tbi.cchText = sizeof (szBuf);
			toolbar.SetButtonInfo(IDC_TOOLBARBUTTON+0, lptbbi);
			//TOOLTIP: GetResString(IDS_CONNECTTOANYSERVER)
			//toolbar.AutoSize();

			statusbar.SetIcon(5,connicons[0]);
			if (!iconOnly) {
				statusbar.SetText(GetResString(IDS_NOTCONNECTED),5,0);
				AddLogLine(true,IDS_DISCONNECTED);
				statusbar.SetTipText(5,_T(""));
			}
			ShowUserCount(0,0);
		}

	}

	EMULE_CATCH2
}

void CemuleDlg::ShowUserCount(uint32 users_toshow, uint32 files_toshow)
{
	EMULE_TRY

	uint32 totaluser, totalfile;
	totaluser = totalfile = 0;
	if( users_toshow || files_toshow )
	 	theApp.serverlist->GetUserFileStatus( totaluser, totalfile );
	CString sBuffer; // kuchin
	sBuffer.Format(_T("%u                                "),users_toshow);		//Cax2 spaces needed to activate tooltip
	statusbar.SetText(sBuffer,2,0);
#ifdef OLD_SOCKETS_ENABLED
	if(theApp.serverconnect->IsConnected())
	{
		sBuffer.Format(_T("%s: %u (%s) | %s: %u (%s)"), GetResString(IDS_UUSERS), users_toshow, CastItoIShort(totaluser), GetResString(IDS_FILES), files_toshow, CastItoIShort(totalfile)); 
		statusbar.SetTipText(2,sBuffer);
	} else {
		statusbar.SetTipText(2,GetResString(IDS_STATS_WAITCONN));
	}
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH2
}

void CemuleDlg::ShowMessageState(uint8 iconnr)
{
	EMULE_TRY

	statusbar.SetIcon(1,imicons[iconnr]);

	EMULE_CATCH2
}


//v- eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
void CemuleDlg::ShowTransferRate(bool bUpdateAll)
{
	EMULE_TRY

	CString sBuffer, sUpload, sDownload;

	//Cax2 - more detailed upload speed: 5 sec average instead of 40 sec average....
	// eklmn: calculate only once
	float lastuprate_kB = (float)theApp.uploadqueue->GetDatarateShown()/1024;
	float lastdownrate_kB = (float)theApp.downloadqueue->GetDatarate()/1024;

	float lastuprateoverhead_kB = (float)theApp.uploadqueue->GetUpDatarateOverhead()/1024;
	float lastdownrateoverhead_kB = (float)theApp.downloadqueue->GetDownDatarateOverhead()/1024;

	//string preparation doesn't depend on output
	if (theApp.glob_prefs->ShowOverhead()) {
		sBuffer.Format(GetResString(IDS_UPDOWNLONG),lastuprate_kB, lastuprateoverhead_kB, lastdownrate_kB, lastdownrateoverhead_kB);
		sUpload.Format(_T("%.2f (%.2f)"),lastuprate_kB, lastuprateoverhead_kB);
		sDownload.Format(_T("%.2f (%.2f)"),lastdownrate_kB, lastdownrateoverhead_kB);
	}
	else {
		sBuffer.Format(GetResString(IDS_UPDOWN),lastuprate_kB, lastdownrate_kB);
		sUpload.Format(_T("%.2f"),lastuprate_kB);
		sDownload.Format(_T("%.2f"),lastdownrate_kB);
	}

	// set SpeedMeterValues if option is activated
	if(theApp.glob_prefs->GetShowToolbarSpeedMeter())
		toolbar.SetSpeedMeterValues((int)lastuprate_kB, (int)lastdownrate_kB);

	// update window only
	if( IsWindowVisible() || bUpdateAll) {
		statusbar.SetText(sUpload,3,0);
		statusbar.SetText(sDownload,4,0);
		statusbar.SetIcon(3,transicons[(lastuprate_kB)?1:0]);
		statusbar.SetIcon(4,transicons[(lastdownrate_kB)?3:2]);

		transferwnd.UpdateDownloadHeader();
		transferwnd.UpdateUploadHeader();
	}

	// update tray only
	if(TrayIsVisible() || bUpdateAll) {
		// set trayicon-icon
		int iMaxValue = theApp.glob_prefs->GetMaxGraphDownloadRate();
		if(iMaxValue < theApp.glob_prefs->GetMaxGraphUploadRate())
			iMaxValue = theApp.glob_prefs->GetMaxGraphUploadRate();

		int DownRateProcent = (int)ceil((lastdownrate_kB*100)/theApp.glob_prefs->GetMaxGraphDownloadRate());
		if (DownRateProcent>100) DownRateProcent=100;

/*		// DbT:ShowServer (&SyruS)
		CString sServer;
#ifdef OLD_SOCKETS_ENABLED
		if (theApp.serverconnect->IsConnecting())
			sServer = GetResString(IDS_CONNECTING);
		else if (theApp.serverconnect->IsConnected())
			sServer.Format(_T("%s: %s"),GetResString(IDS_SERVER),theApp.serverconnect->GetCurrentServer()->GetListName());
		else
			sServer = GetResString(IDS_NOTCONNECTED);
#endif //OLD_SOCKETS_ENABLED

		if(sServer.GetLength() >= 38) sServer= sServer.Left(35) + _T("...");
		// Workaround problem with tooltip on Win9x
		if(!(LOBYTE(theApp.glob_prefs->GetWindowsVersion()) == 0x04))
			sServer.Append(_T("\n")+sBuffer);
		else
			sServer.Append(_T(" | ")+sBuffer);
		// DbT:End

		TraySetToolTip(sServer);
*/
		TraySetToolTip(sBuffer);

		//eklmn: it's better to do TrayUpdate here, cause of TrayToolTip
		UpdateTrayIcon(DownRateProcent);
	}
	if (!TrayIsVisible() && theApp.glob_prefs->ShowRatesOnTitle()) {
		CString buffer;
		buffer.Format(_T("(U:%.1f D:%.1f) eMule Plus v%s"),lastuprate_kB, lastdownrate_kB, CURRENT_VERSION_LONG);
		SetWindowText(buffer);
	}

	EMULE_CATCH2
}
// ^-eklmn: bugfix(11): crazy output in statusbar (update only tray or window)

void CemuleDlg::OnCancel()
{
	EMULE_TRY

	if (theApp.glob_prefs->DoMinToTray()) 
	{
		TrayShow();
		ShowWindow(SW_HIDE);
	} 
	else 
	{
		ShowWindow(SW_MINIMIZE);
	}

	ShowTransferRate(); //eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
	EMULE_CATCH2
}

void CemuleDlg::SetActiveDialog(CDialog* dlg)
{
	EMULE_TRY

	if(dlg == activewnd)
		return;
	activewnd->ShowWindow(SW_HIDE);
	dlg->ShowWindow(SW_SHOW);
	activewnd = dlg;
	if (dlg==&serverwnd) toolbar.PressMuleButton(IDC_TOOLBARBUTTON+1);
	else if (dlg==&transferwnd) toolbar.PressMuleButton(IDC_TOOLBARBUTTON+2);
	else if (dlg==&searchwnd) toolbar.PressMuleButton(IDC_TOOLBARBUTTON+3);
	else if (dlg==&sharedfileswnd) toolbar.PressMuleButton(IDC_TOOLBARBUTTON+4);
	else if (dlg==&chatwnd) {toolbar.PressMuleButton(IDC_TOOLBARBUTTON+5);;theApp.emuledlg->chatwnd.chatselector.ShowChat();}
	else if (dlg==&ircwnd) toolbar.PressMuleButton(IDC_TOOLBARBUTTON+6);
	else if (dlg==&statisticswnd) {toolbar.PressMuleButton(IDC_TOOLBARBUTTON+7);statisticswnd.ShowStatistics();}

	EMULE_CATCH2
}

void CemuleDlg::OnSize(UINT nType,int cx,int cy)
{
	EMULE_TRY

	CTrayDialog::OnSize(nType,cx,cy);
	ResizeStatusBar();

	EMULE_CATCH2
}

void CemuleDlg::ResizeStatusBar()		//Cax2
{
	CRect rect;
	statusbar.GetClientRect(&rect);
	int widths[6] = { rect.right-492, rect.right-470, rect.right-400, rect.right-330, rect.right-260,-1 };
	if (theApp.glob_prefs->ShowOverhead())
	{
		widths[3]=rect.right-295; widths[4]=rect.right-190;
	}
	statusbar.SetParts(6, widths);
}

LRESULT CemuleDlg::OnWMData(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	tagCOPYDATASTRUCT* data = (tagCOPYDATASTRUCT*)lParam;
	if (data->dwData == OP_ED2KLINK){
		FlashWindow(true);
		if( theApp.glob_prefs->IsBringToFront() ){
			if (IsIconic())
				ShowWindow(SW_SHOWNORMAL);
			else if (TrayHide()){
				ShowWindow(SW_SHOW);
			}
		else
			SetForegroundWindow();
		}
		try {
			CString link2;			
			link2 = CString((char*)data->lpData,data->cbData);
			link2.Replace(_T("%7c"),_T("|"));
			CString link(URLDecode(link2));
			CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(link);
			_ASSERT( pLink !=0 );
			switch (pLink->GetKind()) {
			case CED2KLink::kFile:
				{
					CED2KFileLink* pFileLink = pLink->GetFileLink();
					_ASSERT(pFileLink !=0);
					theApp.downloadqueue->AddFileLinkToDownload(pFileLink);
				}
				break;
			case CED2KLink::kServerList:
				{
					CED2KServerListLink* pListLink = pLink->GetServerListLink(); 
					_ASSERT( pListLink !=0 ); 
					CString strAddress = pListLink->GetAddress(); 
					if(strAddress.GetLength() != 0)
						theApp.emuledlg->serverwnd.UpdateServerMetFromURL(strAddress);
				}
				break;
			case CED2KLink::kServer:
				{
					CString defName;
					CED2KServerLink* pSrvLink = pLink->GetServerLink();
					_ASSERT( pSrvLink !=0 );
					CServer* pSrv = new CServer(pSrvLink->GetPort(),pSrvLink->GetIP());		// netwolf 07.05.03 support non-ip ed2k server link
					_ASSERT( pSrv !=0 );
					pSrvLink->GetDefaultName(defName);
					pSrv->SetListName(defName.GetBuffer());

					// Barry - Default all new servers to high priority
					pSrv->SetPreference(CServer::ePR_HIGH);

					if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(pSrv,true)) 
						delete pSrv; 
					else
						AddLogLine(true,GetResString(IDS_SERVERADDED), pSrv->GetListName());
				}
				break;
			default:
				break;
			}
			delete pLink;
		} catch(...) {
			OUTPUT_DEBUG_TRACE();
			AddLogLine(true, IDS_LINKNOTADDED);
		}
	} else if (data->dwData==OP_CLCOMMAND){
		// command line command received
		CString clcommand;
		clcommand= (char*)data->lpData;
		clcommand.MakeLower();
		AddLogLine(true,_T("CLI: %s"),clcommand);

		if (clcommand=="connect")
		{
			StartConnection();
			return true;
		}
#ifdef OLD_SOCKETS_ENABLED
		if (clcommand=="disconnect")
		{
			theApp.serverconnect->Disconnect();
			return true;
		}
#endif //OLD_SOCKETS_ENABLED
		if (clcommand=="resume")
		{
			theApp.downloadqueue->StartPausedDownload(theApp.glob_prefs->GetAllcatType());
			return true;
		}
		if (clcommand=="exit")
		{
			OnClose();
			return true;
		}
		if (clcommand=="reload")
		{
			theApp.sharedfiles->Reload();
			return true;
		}
		if (clcommand=="restore")
		{
			RestoreWindow();
			return true;
		}
		if (clcommand.Left(7).MakeLower()=="limits=" && clcommand.GetLength()>8)
		{
			CString down=_T("");
			CString up=clcommand.Mid(7);
			int pos=up.Find(',');
			if (pos>0)
			{
				down=up.Mid(pos+1);
				up=up.Left(pos);
			}
			if (down.GetLength()>0) theApp.glob_prefs->SetMaxDownload(_tstoi(down));
			if (up.GetLength()>0) theApp.glob_prefs->SetMaxUpload(_tstoi(up));

			return true;
		}

		if (clcommand=="help" || clcommand=="/?")
		{
			// show usage
			return true;
		}

		if (clcommand=="status")
		{
			CString pString;

			// todo: output to console
			
			pString.Format(_T("%sstatus.log"),theApp.glob_prefs->GetAppDir());
			FILE* file = _tfopen(pString , _T("w"));

#ifdef OLD_SOCKETS_ENABLED
			if (theApp.serverconnect->IsConnected()) pString=GetResString(IDS_CONNECTED); else
				if (theApp.serverconnect->IsConnecting()) pString=GetResString(IDS_CONNECTING); else pString=GetResString(IDS_DISCONNECTED);
			_ftprintf(file, pString);
#endif //OLD_SOCKETS_ENABLED

			pString.Format(_T("\n")+GetResString(IDS_UPDOWN),(float)theApp.uploadqueue->GetDatarate()/1024, (float)theApp.downloadqueue->GetDatarate()/1024);
			_ftprintf(file, pString);

			pString=_T("\n")+transferwnd.m_wndDownloadList.getTextList();
			_ftprintf(file, pString);
			
			fclose(file);
			return true;
		}
		// show "unknown command";
	}
	return true;

	EMULE_CATCH2

	return false;
}

LRESULT CemuleDlg::OnFileHashed(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	CKnownFile* result = (CKnownFile*)lParam;
	if (wParam){
		CPartFile* requester = (CPartFile*)wParam;
		requester->PartFileHashFinished(result);
	}
	else{
		theApp.sharedfiles->filelist->SafeAddKFile(result);
		theApp.sharedfiles->SafeAddKFile(result);	
	}
	return true;

	EMULE_CATCH2;

	return false;
}

void CemuleDlg::OnClose()
{
	EMULE_TRY

	if (theApp.m_app_state == theApp.APP_STATE_RUNNING )
	if (theApp.glob_prefs->IsConfirmExitEnabled()) 
			if (IDNO==MessageBox(GetResString(IDS_MAIN_EXIT),GetResString(IDS_MAIN_EXITTITLE),MB_YESNO | MB_DEFBUTTON2)) return;

	// we should call this before changing the state to APP_STATE_SHUTINGDOWN because
	// otherwise any log message inside this function (and there are few) will produce 
	// message box 
#ifdef OLD_SOCKETS_ENABLED
	if ( theApp.serverconnect->IsConnected() )
		theApp.serverconnect->Disconnect();
#endif //OLD_SOCKETS_ENABLED

   	theApp.m_app_state = theApp.APP_STATE_SHUTINGDOWN;

	theApp.OnlineSig(); // Added By Bouc7

	// TODO: Add your message handler code here and/or call default
	WINDOWPLACEMENT wp;wp.length=sizeof(wp);GetWindowPlacement(&wp);
	theApp.glob_prefs->SetWindowLayout(wp);

    // obaldin: disable redraws while shutting down
    // should take care of some crashes on exit
	transferwnd.m_wndDownloadList.SetRedraw(false);
	transferwnd.m_wndUploadList.SetRedraw(false);
	transferwnd.m_wndQueueList.SetRedraw(false);
	searchwnd.searchlistctrl.SetRedraw(false);
	sharedfileswnd.sharedfilesctrl.SetRedraw(false);
	ircwnd.serverChannelList.SetRedraw(false);
    transferwnd.m_wndInfoList.SetRedraw(false);
    chatwnd.chatselector.SetRedraw(false);
    statisticswnd.SetRedraw(false);
    transferwnd.SetRedraw(false);
    searchwnd.SetRedraw(false);
    sharedfileswnd.SetRedraw(false);
    ircwnd.SetRedraw(false);
    chatwnd.SetRedraw(false);
    //SetRedraw(false);  // is it enough to do only this, or do we need everything before too??

	transferwnd.m_wndDownloadList.SaveSettings(CPreferences::tableDownload);
	transferwnd.m_wndUploadList.SaveSettings(CPreferences::tableUpload);
	transferwnd.m_wndQueueList.SaveSettings(CPreferences::tableQueue);
	searchwnd.searchlistctrl.SaveSettings(CPreferences::tableSearch);
	sharedfileswnd.sharedfilesctrl.SaveSettings(CPreferences::tableShared);
	serverwnd.serverlistctrl.SaveSettings(CPreferences::tableServer);
	ircwnd.serverChannelList.SaveSettings(CPreferences::tableIrc);

	theApp.glob_prefs->Add2TotalDownloaded(theApp.stat_sessionReceivedBytes);
	theApp.glob_prefs->Add2TotalUploaded(theApp.stat_sessionSentBytes);
	theApp.glob_prefs->SetDetailColumnWidth(transferwnd.GetDetailColumnWidth());
	theApp.glob_prefs->Save();


	// Barry - Restore old registry if required
	if (theApp.glob_prefs->AutoTakeED2KLinks())
		RevertReg();
 
    // obaldin: do we still need te following? Now that we disable the redraws?
    sharedfileswnd.sharedfilesctrl.DeleteAllItems();
	transferwnd.m_wndUploadList.DeleteAllItems();
	transferwnd.m_wndQueueList.DeleteAllItems();
    transferwnd.m_wndDownloadList.DeleteAllItems();
	chatwnd.chatselector.DeleteAllItems();
	searchwnd.searchlistctrl.DeleteAllItems();

	//--- xrmb:parttraffic ---
	//--- we need this, because if it is not here emule will crash during repaint of not existing list-items ---
	sharedfileswnd.sharedfilesctrl.DeleteAllItems();
	//--- :xrmb ---

	// All dialog windows created should be destroyed
	serverwnd.DestroyWindow();
	transferwnd.DestroyWindow();
	searchwnd.DestroyWindow();
	sharedfileswnd.DestroyWindow();
	ircwnd.DestroyWindow();
	chatwnd.DestroyWindow();
	statisticswnd.DestroyWindow();

	theApp.clientlist->DeleteAll();
	theApp.knownfiles->Save();	//Cax2 - moved here, should avoid crashes when closing & downloading.

	CTrayDialog::OnCancel();

	//N@boleo (Backup feature)
	if (theApp.glob_prefs->GetAutoBackup())
	{
		theApp.emuledlg->RunBackupNow(true);
	}

	EMULE_CATCH2
}

void CemuleDlg::OnTrayRButtonUp(CPoint pt)
{
	EMULE_TRY

	if(m_pSystrayDlg)
	{
		m_pSystrayDlg->BringWindowToTop();
		return;
	}
	
	m_pSystrayDlg = new CMuleSystrayDlg(this,pt, 
									theApp.glob_prefs->GetMaxGraphUploadRate(), 
									theApp.glob_prefs->GetMaxGraphDownloadRate(),
									theApp.glob_prefs->GetMaxUpload(),
									theApp.glob_prefs->GetMaxDownload());
	if(m_pSystrayDlg)
	{
		UINT nResult = m_pSystrayDlg->DoModal();
		delete m_pSystrayDlg;
		m_pSystrayDlg = NULL;
		switch(nResult)
		{
			case IDC_TOMAX:
				QuickSpeedOther(MP_QS_UA);
				break;
			case IDC_TOMIN:
				QuickSpeedOther(MP_QS_PA);
				break;
			case IDC_RESTORE:
				RestoreWindow();
				break;
			case IDC_CONNECT:
				StartConnection();
				break;
			case IDC_DISCONNECT:
				CloseConnection();
				break;
			case IDC_EXIT:
				OnClose();
				break;
			case IDC_PREFERENCES:
			{	
				static int iOpen = 0;
				if(!iOpen)
				{
					iOpen = 1;
					preferenceswnd.DoModal();
					iOpen = 0;
				}
				break;
			}
			default:
				break;
		}
	}

	EMULE_CATCH2
}


void CemuleDlg::StartConnection()
{
	EMULE_TRY

	AddLogLine(true, IDS_CONNECTING);
	if ( serverwnd.serverlistctrl.GetSelectedCount()>1 )
	{
		serverwnd.serverlistctrl.PostMessage(WM_COMMAND,MP_CONNECTTO,0L);
	}
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		theApp.serverconnect->ConnectToAnyServer();
#else
		theApp.pEngine->ConnectToAnyServer();
#endif //OLD_SOCKETS_ENABLED
	}
	ShowConnectionState(false);

	EMULE_CATCH2
}

void CemuleDlg::CloseConnection()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	theApp.serverconnect->Disconnect();
#endif //OLD_SOCKETS_ENABLED
	theApp.OnlineSig(); // Added By Bouc7 

	EMULE_CATCH2
}

void CemuleDlg::RestoreWindow()
{
	EMULE_TRY

	if (TrayIsVisible())
		TrayHide();	
	ShowWindow(SW_SHOW);

	EMULE_CATCH2
}

void CemuleDlg::ShowStatistics() 
{
	statisticswnd.ShowStatistics();	
}

void CemuleDlg::UpdateTrayIcon(int procent)
{
	EMULE_TRY

	//HICON mytrayIcon;
	//if (mytrayIcon!=NULL) DestroyIcon(mytrayIcon);
	// set the limits of where the bar color changes (low-high)
	int pLimits16[1] = {100};

	// set the corresponding color for each level
	COLORREF pColors16[1] = { RGB(1,255,1) };;

	// start it up
#ifdef OLD_SOCKETS_ENABLED
	if(theApp.serverconnect->IsConnected() && !theApp.serverconnect->IsLowID())
		trayIcon.Init(sourceTrayIcon,100,1,1,16,16, RGB(37,97,37));
	else if(theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID())
		trayIcon.Init(sourceTrayIconLowID,100,1,1,16,16, RGB(37,97,37));
	else 
#endif //OLD_SOCKETS_ENABLED
		trayIcon.Init(sourceTrayIconGrey,100,1,1,16,16, RGB(37,97,37));
		
	// load our limit and color info
	trayIcon.SetColorLevels(pLimits16,pColors16,1);

	// generate the icon (destroy these icon using DestroyIcon())
	int pVals16[1] = {procent};

	mytrayIcon = trayIcon.Create(pVals16);
	ASSERT (mytrayIcon != NULL);
	if (mytrayIcon)
		TraySetIcon(mytrayIcon);
	TrayUpdate();

	EMULE_CATCH2
}

int CemuleDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	EMULE_TRY

	CTrayDialog::OnCreate(lpCreateStruct);
	/*if (theApp.glob_prefs->UseSplashScreen()){
		ModifyStyleEx(0,WS_EX_LAYERED);
		SetLayeredWindowAttributes(0, 0, LWA_ALPHA);
	}*/
	return 0;

	EMULE_CATCH2

	return -1;
}

//START - enkeyDEV(kei-kun) -TaskbarNotifier-
void CemuleDlg::ShowNotifier(CString Text, int MsgType, bool ForceSoundOFF, bool bMsgEnabled) 
{
	EMULE_TRY

	bool ShowIt = false;
    if (bMsgEnabled) {
		m_wndTaskbarNotifier.Show(Text, MsgType, 500,theApp.glob_prefs->NotificationDisplayTime());
		ShowIt = true;
	}

    if (theApp.glob_prefs->GetUseSoundInNotifier() && !ForceSoundOFF && ShowIt == true)
        PlaySound(theApp.glob_prefs->GetNotifierWavSoundPath(), NULL, SND_FILENAME | SND_NOSTOP | SND_NOWAIT | SND_ASYNC);

	EMULE_CATCH2
}

LRESULT CemuleDlg::OnTaskbarNotifierClicked(WPARAM wParam,LPARAM lParam)
{
	EMULE_TRY

	int msgType = TBN_NULL;
	msgType = m_wndTaskbarNotifier.GetMessageType();	
    	switch(msgType)
	{
	case TBN_CHAT:
		RestoreWindow();
		SetActiveDialog(&chatwnd);
		break;
	case TBN_DLOAD:
		RestoreWindow();
		SetActiveDialog(&transferwnd);
		break;
	case TBN_DLOAD_ADD:
		RestoreWindow();
		SetActiveDialog(&transferwnd);
		break;
	case TBN_IMPORTANTEVENT:
		RestoreWindow();
		SetActiveDialog(&serverwnd);	
		break;
	case TBN_LOG:
		RestoreWindow();
		SetActiveDialog(&serverwnd);	
		break;
	}
    return 0;

	EMULE_CATCH2

	return -1;
}
//END - enkeyDEV(kei-kun) -TaskbarNotifier-

void CemuleDlg::Localize()
{
	EMULE_TRY

	if(m_hWnd)
	{
		toolbar.Localize();
		// start added by InterCeptor (localization) 30.10.02
		if (!statusbar)
			return;

#ifdef OLD_SOCKETS_ENABLED
		if(theApp.serverconnect->IsConnected())
			ShowUserCount(theApp.serverconnect->GetCurrentServer()->GetUsers(),theApp.serverconnect->GetCurrentServer()->GetFiles());
		else
#endif //OLD_SOCKETS_ENABLED
		{
			CString buffer;
			buffer.Format(_T("0                                ")); //Cax2 spaces needed to activate tooltip
			statusbar.SetTipText(2,GetResString(IDS_STATS_WAITCONN));
			statusbar.SetText(buffer,2,0);
			statusbar.SetTipText(5,_T(""));
#ifdef OLD_SOCKETS_ENABLED
			if(theApp.serverconnect->IsConnecting())
				statusbar.SetText(GetResString(IDS_CONNECTING),5,0);
			else
#endif //OLD_SOCKETS_ENABLED
				statusbar.SetText(GetResString(IDS_NOTCONNECTED),5,0);
		}
		ShowTransferRate(true);	//eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
		// end added by InterCeptor (localization) 30.10.02
	}

	EMULE_CATCH2
}

void CemuleDlg::DisConnect()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	if(!theApp.serverconnect->IsConnected()) 
	{
		//connect if not currently connected
		if(!theApp.serverconnect->IsConnecting()) 
			StartConnection(); 
		else 
		{
			theApp.serverconnect->StopConnectionTry();
			ShowConnectionState(false);
		}
	}
	else
#endif //OLD_SOCKETS_ENABLED
		//disconnect if currently connected
		CloseConnection();

	EMULE_CATCH2
}

BOOL CemuleDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	switch(wParam)
	{	
		case IDC_TOOLBARBUTTON + 0:
			DisConnect();
			break;
		case IDC_TOOLBARBUTTON + 1:
			SetActiveDialog(&serverwnd);
			toolbar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + 2:
			SetActiveDialog(&transferwnd);
			toolbar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + 3:
			SetActiveDialog(&searchwnd);
			toolbar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + 4:
			SetActiveDialog(&sharedfileswnd);
			toolbar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + 5:
			SetActiveDialog(&chatwnd);
			toolbar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + 6:
			SetActiveDialog(&ircwnd);
			toolbar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + 7:
			SetActiveDialog(&statisticswnd);
			toolbar.PressMuleButton(wParam);
			break;
		case IDC_TOOLBARBUTTON + 8:
			toolbar.PressButton(IDC_TOOLBARBUTTON+8,TRUE);
			preferenceswnd.DoModal();
			toolbar.PressButton(IDC_TOOLBARBUTTON+8,FALSE);
			break;
		default: break;
	}	

	return CTrayDialog::OnCommand(wParam, lParam);

	EMULE_CATCH2

	return 0;
}

/* // Added by Jmpep above
void CemuleDlg::QuickSpeedUpload(UINT nID)
{
	EMULE_TRY

	switch (nID) {
		case MP_QS_U10: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.1)); break ;
		case MP_QS_U20: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.2)); break ;
		case MP_QS_U30: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.3)); break ;
		case MP_QS_U40: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.4)); break ;
		case MP_QS_U50: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.5)); break ;
		case MP_QS_U60: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.6)); break ;
		case MP_QS_U70: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.7)); break ;
		case MP_QS_U80: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.8)); break ;
		case MP_QS_U90: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate()*0.9)); break ;
		case MP_QS_U100: theApp.glob_prefs->SetMaxUpload(theApp.glob_prefs->GetMaxGraphUploadRate()); break ;
		case MP_QS_UPC: theApp.glob_prefs->SetMaxUpload(UNLIMITED); break ;
		case MP_QS_UP10: theApp.glob_prefs->SetMaxUpload(GetRecMaxUpload()); break ;
	}

	EMULE_CATCH2
}

void CemuleDlg::QuickSpeedDownload(UINT nID)
{
	EMULE_TRY

	switch (nID) {
		case MP_QS_D10: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.1)); break ;
		case MP_QS_D20: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.2)); break ;
		case MP_QS_D30: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.3)); break ;
		case MP_QS_D40: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.4)); break ;
		case MP_QS_D50: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.5)); break ;
		case MP_QS_D60: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.6)); break ;
		case MP_QS_D70: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.7)); break ;
		case MP_QS_D80: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.8)); break ;
		case MP_QS_D90: theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate()*0.9)); break ;
		case MP_QS_D100: theApp.glob_prefs->SetMaxDownload(theApp.glob_prefs->GetMaxGraphDownloadRate()); break ;
		case MP_QS_DC: theApp.glob_prefs->SetMaxDownload(UNLIMITED); break ;
	}

	EMULE_CATCH2
}
*/
void CemuleDlg::QuickSpeedOther(UINT nID)
{
	EMULE_TRY

	switch (nID) {
		case MP_QS_PA: theApp.glob_prefs->SetMaxUpload((uint16)(1)); theApp.glob_prefs->SetMaxDownload((uint16)(1)); break ;
		case MP_QS_UA: theApp.glob_prefs->SetMaxUpload((uint16)(theApp.glob_prefs->GetMaxGraphUploadRate())); theApp.glob_prefs->SetMaxDownload((uint16)(theApp.glob_prefs->GetMaxGraphDownloadRate())); break ;

	}

	EMULE_CATCH2
}


int CemuleDlg::GetRecMaxUpload() 
{
	EMULE_TRY
	
	if (theApp.glob_prefs->GetMaxGraphUploadRate()<7) return 0;
	if (theApp.glob_prefs->GetMaxGraphUploadRate()<15) return theApp.glob_prefs->GetMaxGraphUploadRate()-3;
	return (theApp.glob_prefs->GetMaxGraphUploadRate()-4);

	EMULE_CATCH2

	return 0;
}

BOOL CemuleDlg::OnQueryEndSession() 
{
	EMULE_TRY

	if (!CTrayDialog::OnQueryEndSession())
		return FALSE; 

	if ( theApp.m_app_state == theApp.APP_STATE_DONE )
	{
		return TRUE; 
	}
	else if ( theApp.m_app_state   ==   theApp.APP_STATE_RUNNING)
   	{ 
		theApp.m_app_state = theApp.APP_STATE_SHUTINGDOWN; 
   		//Cax2 don't ask for confirmation when receiving a shutdown message...
		// [Lord KiRon]
		//EndDialog(0); 
		CDialog::OnCancel(); // for some reason EndDialog() causes sometimes assertion in Window main loop 
		// [/Lord KiRon]
		return TRUE;	//MooseTea fix
   	} 

	EMULE_CATCH2

   	return FALSE; 
}

LRESULT CemuleDlg::OnWebServerConnect(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	theApp.serverconnect->ConnectToServer(*(CServer*)wParam);
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH2

	return 0;
}

LRESULT CemuleDlg::OnWebServerRemove(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	theApp.emuledlg->serverwnd.serverlistctrl.RemoveServer((CServer*)wParam); // sivka's bugfix

	EMULE_CATCH2

	return 0;
}
//purity
LRESULT CemuleDlg::OnWebServerAddToStatic(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	theApp.emuledlg->serverwnd.serverlistctrl.StaticServerFileAppend((CServer*)wParam);
	EMULE_CATCH2

	return 0;
}
//purity
LRESULT CemuleDlg::OnWebServerRemoveFromStatic(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	theApp.emuledlg->serverwnd.serverlistctrl.StaticServerFileRemove((CServer*)wParam);

	EMULE_CATCH2

	return 0;
}

LRESULT CemuleDlg::OnProcessTaskUI(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

#ifdef NEW_SOCKETS
	CTask *pTask = (CTask*)wParam;
	if(pTask)
	{
		pTask->ProcessForUI(*theApp.pEngine);
		delete pTask;
	}
#endif //NEW_SOCKETS

	EMULE_CATCH2

	return 0;
}

LRESULT CemuleDlg::OnWebSharedFilesReload(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	theApp.sharedfiles->Reload(true);

	EMULE_CATCH2

	return 0;
}
// Barry - To find out if app is running or shutting/shut down
bool CemuleDlg::IsRunning()
{
	return (theApp.m_app_state == CemuleApp::APP_STATE_RUNNING);
}

void CemuleDlg::OnNcDestroy()
{
	//see KB138681 [TwoBottle Mod]
	AfxGetApp()->m_pMainWnd = NULL;
	CTrayDialog::OnNcDestroy();	
}

BOOL CemuleDlg::TrayShow(void)
{
		// set trayicon-icon
	int DownRateProcent = (int)ceil((lastdownrate/10.24)/theApp.glob_prefs->GetMaxGraphDownloadRate());
	if (DownRateProcent>100) 
		DownRateProcent=100;

	UpdateTrayIcon(DownRateProcent);

	return CTrayDialog::TrayShow();
}

void CemuleDlg::RunBackupNow(bool automated)
{
	if (theApp.glob_prefs->GetBackupDatFiles())
		BackupFromAppDir("*.dat",automated);
	if (theApp.glob_prefs->GetBackupMetFiles())
		BackupFromAppDir("*.met",automated);
	if (theApp.glob_prefs->GetBackupIniFiles())
		BackupFromAppDir("*.ini",automated);
	if (theApp.glob_prefs->GetBackupPartMetFiles())
		BackupFromTempDir("*.part.met",automated);
	if (theApp.glob_prefs->GetBackupPartFiles())
	{
		if (!automated)
		{
			if (MessageBox(GetResString(IDS_BACKUP_LONGTIME),GetResString(IDS_BACKUP_SURE),MB_ICONQUESTION|MB_YESNO)== IDYES)
				BackupFromTempDir("*.part",automated);
		}
		else
		{
			BackupFromTempDir("*.part",automated);
		}
	}
	if (!automated)
		MessageBox(GetResString(IDS_BACKUP_SUCCESS),GetResString(IDS_BACKUP_COMPLETE),MB_OK);
}

void CemuleDlg::BackupFromAppDir(LPCSTR extensionToBack,bool automated)  
{
	CString szConfigDirPath = CString(theApp.glob_prefs->GetConfigDir());
	CString buffer;
	buffer.Format(_T("%s\\"),theApp.glob_prefs->GetBackupDir());
	char szBackupPath[MAX_PATH];
	lstrcpy(szBackupPath,buffer);

	// Create a new directory if one does not exist
	if(!PathFileExists(szBackupPath))
		CreateDirectory(szBackupPath, NULL);
	
	//Copying files
	BackupFiles(extensionToBack,automated,szConfigDirPath,szBackupPath);
}

void CemuleDlg::BackupFromTempDir(LPCSTR extensionToBack, bool automated)
{  
	CString szTempPath = CString(theApp.glob_prefs->GetTempDir()); 
	CString buffer;
	buffer.Format(_T("%s\\Temp\\"),theApp.glob_prefs->GetBackupDir());
	char szBackupTempSubPath[MAX_PATH];
	lstrcpy(szBackupTempSubPath,buffer);

	// Create a new directory if one does not exist
	if(!PathFileExists(theApp.glob_prefs->GetBackupDir()))
		CreateDirectory(theApp.glob_prefs->GetBackupDir(), NULL);
	if(!PathFileExists(szBackupTempSubPath))
		CreateDirectory(szBackupTempSubPath, NULL);

	//Copying files
	BackupFiles(extensionToBack,automated,szTempPath,szBackupTempSubPath);
}


void CemuleDlg::BackupFiles(LPCSTR extensionToBack,bool automated, CString szPath, CString szBackupPath)
{
	WIN32_FIND_DATA fileData;   
	HANDLE hSearch;
	BOOL fFinished = FALSE;     
	BOOL error = FALSE;  
	BOOL overWrite = TRUE;
	char buffer[200];
	char szNewPath[MAX_PATH];

	// Start searching for files in the directory.   
	SetCurrentDirectory(szPath);  

	hSearch = FindFirstFile(extensionToBack, &fileData);   

	if (hSearch == INVALID_HANDLE_VALUE)   
	{   
		error = TRUE;  
	}   

	// Copy each file to the backup directory 
	while (!fFinished && !error)   
	{   
		lstrcpy(szNewPath,szBackupPath);
		lstrcat(szNewPath,fileData.cFileName);   

		if (PathFileExists(szNewPath))  
		{  
			if (!automated)
			{
				if (!theApp.glob_prefs->GetBackupOverwrite())
				{
					sprintf(buffer,GetResString(IDS_BACKUP_EXIST),fileData.cFileName);
					if (MessageBox(buffer,GetResString(IDS_BACKUP_OVER),MB_ICONQUESTION|MB_YESNO)== IDYES)
						overWrite = TRUE;
					else 
						overWrite = FALSE;
				}
			}
			else
			{
				overWrite = TRUE;
			}
		}  
		if (overWrite)  
			CopyFile(fileData.cFileName, szNewPath, FALSE);
		if (!automated)
			AddDebugLogLine(false,_T("Backup %s done"),szNewPath);

		if (!FindNextFile(hSearch, &fileData))   
		{  
			if (GetLastError() == ERROR_NO_MORE_FILES)   
			{   
				fFinished = TRUE;   
			}   
			else   
			{   
				error = TRUE;  
			}   
		}  

	}   
	// Close the search handle.   
	if (!FindClose(hSearch))   
	{   
		error = TRUE;  
	}   
	if (error)
	{
		AddDebugLogLine(false,_T("%s : %s "),GetResString(IDS_BACKUP_ERROR2),GetResString(IDS_BACKUP_ERROR));
		if(!automated)
			MessageBox(GetResString(IDS_BACKUP_ERROR),GetResString(IDS_BACKUP_ERROR2),MB_OK);
	}
}
